{$A+,B-,E-,F+,G+,I-,N-,O+,R-,X+}
{G und S ber IDE}
unit BMPVIEW;

interface uses crt,graph,viewprim,viewsl;
type bmpfheadertyp=Record
       id:word; 	{'BM', 19778}
       bfSize:Longint;
       reserviert1:word;
       reserviert2:word;
       bfOffs:Longint;  {Offset Datenbereich}
     end;
type bmpiheadertyp=Record
       biSize:Longint;
       biWidth:LongInt;
       biHeight:LongInt;
       Farbebenen:Word;
       Bipp:Word;
       biCompr:LongInt;
       biSizeIm:LongInt;
       bixpixperm:LongInt;
       biypixperm:LongInt;
       biColUsed:LongInt;
       biColImpt:LongInt;
     end;
type rgbquadtype=record
                   blau,
                   gruen,
                   rot,
                   muell:Byte;
                  end;
procedure liesbmp;

implementation

function align2(w:word):word;
{w ist eine Bytezahl, die auf die
 nchste Word-Grenze gerundet wird}
begin
  align2:=((w+1)div 2)*2
end;

procedure liesrle16zeile(var zeile:bytefeldtyp);
{Bildpunktweise}
var puffer:bytefeldtyp;
var code,code2,code3,b1,b2:byte;
var position:word; {Nibbleposition}
var i:word;
  procedure addpixel(farbe:byte);
  begin
    if not odd(position) then asm shl farbe,4 end;
    zeile[position div 2]:=zeile[position div 2] or farbe;
    inc(position);
  end;
begin
  position:=0;
  fillchar(zeile,sizeof(zeile),#0);
  code2:=1; {nicht null}
  repeat
    blockread(wpg,code,1);
    if code=0 then
    begin {unterschiedliche Bytes}
      blockread(wpg,code2,1);
      if code2>2 {Sonst Endekennung}
      then
      begin
        blockread(wpg,puffer,align2((code2+1) div 2));
        i:=0;
        repeat
          b1:=puffer[i div 2];
          addpixel(b1 shr 4);
          inc(i);
          if i<code2 then
          addpixel(b1 and 15);
          inc(i);
        until i>=code2;
      end
    end
    else
    begin {gleiche Bildpunkte}
      blockread(wpg,code3,1);
      if not(odd (position) or odd (code))
      then
      begin
        fillchar(zeile[position div 2],code div 2,char(code3));
        inc(position,code);
      end
      else
      begin
      b1:=code3 shr 4;
      b2:=code3 and 15;
      i:=0;
      repeat
        addpixel(b1);
        inc(i);
        if i<code then
        addpixel(b2);
        inc(i);
      until i>=code;
      end;
    end;
  until (code2<3) or (ioresult<>0);
end;

procedure liesrle256zeile(var zeile:bytefeldtyp);
{Byteweise}
var code,code2,code3:byte;
var position:word;
begin
  position:=0;
  code2:=1; {nicht null}
  repeat
    blockread(wpg,code,1);
    if code=0 then
    begin {unterschiedliche Bytes}
      blockread(wpg,code2,1);
      if code2>2 {Sonst Endekennung}
      then blockread(wpg,zeile[position],code2);
    end
    else
    begin {gleiche Bildpunkte}
      blockread(wpg,code3,1);
      fillchar(zeile[position],code,char(code3));
      inc(position,code);
    end;
  until (code2<3) or (ioresult<>0);
end;

procedure liesbmp;
Label Fehler;
var s:string;
var i,j,n:integer;
var zeilenzahl,
    zeilenbreite:Integer;
var img:record			{Fr PutImage}
	    breite,
	    hoehe:word;
	    zeile:Bytefeldtyp;
	  end;
var bmpfheader:bmpfheadertyp;
var bmpiheader:bmpiheadertyp;
var rgbquad:rgbquadtype;
var palsize:word;
var farbenzahl:longint;

begin {liesbmp}
  if ioresult<>0 then;
  seek(wpg,0);
  blockread(wpg,bmpfheader,sizeof(bmpfheader));
  if ioresult<>0 then goto fehler;
  blockread(wpg,bmpiheader,sizeof(bmpiheader));
  if ioresult<>0 then goto fehler;
  if (bmpfheader.id<>19778) then goto fehler;

  falschertyp:=false;

  If Zeichnungbegonnen and not keypressed and not ineinanderzeichnen then
  begin
    {Zeichenflche lschen}
    setfillstyle(userfill,HGFarbe);
    setfillPattern(HGMuster,HGfarbe);
    bar(0,0,maxx,maxy);
    Zeichnungbegonnen:=FALSE;
  END;

  Setrgbpalette(0,0,0,0);
  If (bmpiheader.Farbebenen*bmpiheader.bipp=1)
  then SetRGBPalette(1,255,255,255);

  if not (monochrom
       or graustufen
       or (bmpiheader.Farbebenen*bmpiheader.bipp=1))
  then {Palette benutzen}
  palsize:=(bmpfheader.bfoffs-sizeof(bmpfheader)-sizeof(bmpiheader))
           div 4;

  case bmpiheader.bipp of
    1: Farbenzahl:=2;
    4: Farbenzahl:=16;
    8: Farbenzahl:=256;
   24: Farbenzahl:=16777216;
   else farbenzahl:=0;
  end;

  for i:=0 to palsize-1 do
  begin
    blockread(wpg,rgbquad,4);
    with rgbquad do
    setrgbpalette(i,rot,gruen,blau);
  end;

  with bmpiheader do
  If Not Infogefunden then
  WriteSL(', '+ls(biwidth)+' x '+ls(biheight)+' Punkte in '+ls(farbenzahl)+' Farben',false);

  Zeichnungbegonnen:=NOT Ineinanderzeichnen;

  Zeilenzahl:=lmin(maxy,bmpiheader.biheight);

  case bmpiheader.bipp of
    1: Zeilenbreite:=(bmpiheader.biwidth+7) div 8;
    4: Zeilenbreite:=(bmpiheader.biwidth+1) div 2;
    8: Zeilenbreite:=bmpiheader.biwidth;
   24: Zeilenbreite:=bmpiheader.biwidth*3;
  end;
  {auf 32 Bit aufrunden:}
  Zeilenbreite:=4*((zeilenbreite+3)div 4);

  seek(wpg,bmpfheader.bfoffs);
  setviewport(0,0,maxx,maxy,true);
  for n:=0 to Zeilenzahl-1 do
  if not keypressed then
  begin
    case bmpiheader.bicompr of
    0: blockread(wpg,img.zeile,zeilenbreite);
    1: liesrle256zeile(img.zeile);
    2: liesrle16zeile(img.zeile);
    else goto fehler;
    end;

    case bmpiheader.bipp of
    1:
    for i:=0 to (bmpiheader.biwidth div 8)-1 do
    begin
      if (img.zeile[i] and 128)=0 then putpixel(8*i  ,maxy-n,0);
      if (img.zeile[i] and  64)=0 then putpixel(8*i+1,maxy-n,0);
      if (img.zeile[i] and  32)=0 then putpixel(8*i+2,maxy-n,0);
      if (img.zeile[i] and  16)=0 then putpixel(8*i+3,maxy-n,0);
      if (img.zeile[i] and   8)=0 then putpixel(8*i+4,maxy-n,0);
      if (img.zeile[i] and   4)=0 then putpixel(8*i+5,maxy-n,0);
      if (img.zeile[i] and   2)=0 then putpixel(8*i+6,maxy-n,0);
      if (img.zeile[i] and   1)=0 then putpixel(8*i+7,maxy-n,0);
    end;
    4:
    for i:=0 to (bmpiheader.biwidth div 2)-1 do
    begin
      putpixel(2*i,maxy-n,img.zeile[i] shr 4);
      putpixel(2*i+1,maxy-n,img.zeile[i] and 15);
    end;
    8:
    if getmaxcolor=255 then
    begin
    img.hoehe:=0;
    img.breite:=bmpiheader.biwidth-1;
      putimage(0,maxy-n,img,normalput);
    end;
    else goto fehler;
    end;{case}
  end; {schleife ber zeilen}
  setviewport(0,0,getmaxx,getmaxy,false);
Exit;
Fehler:
  setviewport(0,0,getmaxx,getmaxy,false);
  writesl('Ist keine darstellbare BMP-Datei,',true);
  Falschertyp:=True;
end; {LiesPCX}

begin end.
