{$A+,B-,D+,E-,F+,G-,I-,L+,N-,O+,R-,S-,V-,X+}
unit Disk;
interface uses dos;

function bakname(name:string):string;
FUNCTION DirFormat(S:String):string;
Function DateiNameEindeutig(S:String):Boolean;
function fileexist(name:string):Boolean;
function Filecopy(von,nach:string):Boolean;
function DiskBeschreibbar(LW:Char):Boolean;
function DateiGroesse(name:String):longint;
function erasefile(name:string):Boolean;

implementation

Function DateiNameEindeutig(S:String):Boolean;
BEGIN
  DateiNameEindeutig:=(POS('?',s)=0) and (POS('*',s)=0);
END;

function bakname(name:string):string;
begin
  if pos('.',name)=0 then BAKname:=name+'.BAK'
  else BAKname:=copy(name,1,pos('.',name))+'BAK'
end;

FUNCTION DirFormat(S:String):string;
{Macht "DATEINAM.EXT" zu "DATEINAM EXT"}
var d:dirstr;
    n:namestr;
    e:extstr;
BEGIN
     if s='.'  then DirFormat:='dieses VZ  .'
else if s='..' then DirFormat:='oberes VZ ..'
else
begin
  Fsplit(S,d,n,e);
  while length(n)<8 do n:=n+' ';
  if e[1]='.' then e[1]:=' ';
  while length(e)<3 do e:=e+' ';
  DirFormat:=n+e;
end;
END;

function fileexist(name:string):Boolean;
begin
  fileexist:=fsearch(name,'')<>'';
end;

procedure renamefile(name1,name2:string);
var f:file;
begin
  assign(f,name1);
  rename(f,name2);
  if ioresult<>0 then;
end;

function Filecopy(von,nach:string):Boolean;
label fehler;

const groesse=10000;
      maxpzahl=100; {eine Million Byte ist mehr als genug}

type grossfeld=array[1..groesse]of byte;

var ein,aus:file;
    puffer :array[1..maxpzahl] of ^grossfeld;
    gelesen:array[1..maxpzahl] of word;
    lesesumme:longint;
    n,m,pzahl:byte;

begin
  if fileexist(nach) then
    begin
      erasefile(bakname(nach));
      renamefile(nach,bakname(nach));
    end;
  assign(ein,von);
  assign(aus,nach);
  reset(ein,1);
  if ioresult<>0 then goto fehler;
  rewrite(aus,1);
  if ioresult<>0 then goto fehler;
  lesesumme:=0;

  pzahl:=0;
  while maxavail>=groesse do
  begin
    inc(pzahl);
    new(puffer[pzahl]);
  end;

  repeat
    n:=0;
    repeat
      inc(n);
      blockread(ein,puffer[n]^,groesse,gelesen[n]);
    until (n=pzahl) or (gelesen[n]=0);
    m:=0;
    repeat
      inc(m);
      blockwrite(aus,puffer[m]^,gelesen[m]);
    until m=n;
  until gelesen[m]=0;

  close (ein);
  if ioresult<>0 then goto fehler;
  close(aus);
  if ioresult<>0 then goto fehler;

  while pzahl>0 do
  begin
    dispose(puffer[pzahl]);
    dec(pzahl);
  end;

filecopy:=true;
exit;
fehler:
filecopy:=false;
end;

{Test auf Schreibschutz}
function DiskBeschreibbar(LW:Char):Boolean;
VAR f:File;
BEGIN
  assign(f,LW+':@@@@@@@@.@@@');
  rewrite(f);
  If IORESULT=0 then
  BEGIN
    DiskBeschreibbar:=TRUE;
    close(f); if ioresult=0 then;
    erase(f); if ioresult=0 then;
  END
  ELSE
    DiskBeschreibbar:=FALSE;
END;

function DateiGroesse(name:String):longint;
var f:file;
begin
  assign(f,name);
  filemode:=0;
  reset(f,1); if ioresult<>0 then
  Dateigroesse:=0
  else
  Dateigroesse:=filesize(f);
  close(f); if ioresult<>0 then;
  filemode:=2;
end;

function erasefile(name:String):boolean;
var f:file;
begin
  assign(f,name);
  erase(f); erasefile:=ioresult=0;
  close(f); if ioresult<>0 then;
end;

begin end.
