{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
UNIT GREXPORT;

INTERFACE
USES DOS,VIEWPRIM;
CONST AusschnittZiel	:PathStr='';
      AusschnittEXT	:ExtStr='.WPG';

PROCEDURE Komprimiere(var b:bytefeldtyp;var l:integer);
procedure schreibe_fenster(Modus:Byte;
			   maxfarbe,x1,x2,y1,y2,breitenfaktor:longint;
			   name:Pathstr;monochrom:Boolean;
			   var ok:Boolean);
procedure schreibe_zoomfenster(maxfarbe,x1,x2,y1,y2,breitenfaktor:longint;
			       name:string;var ok:Boolean);
procedure schreibe_viertelfenster(maxfarbe,x1,x2,y1,y2,breitenfaktor:longint;
			       name:string;var ok:Boolean);
procedure schreibe_dxf(x1,x2,y1,y2:word;name:string;
		       monochrom:boolean; var ok:boolean);
procedure schreibe_hpgl(x1,x2,y1,y2:word;name:string;
		       var ok:boolean);
procedure schreibe_PCX(x1,x2,y1,y2:word;name:string;
		       monochrom:boolean;var ok:boolean);
procedure schreibe_QWG(x1,x2,y1,y2:word;name:string;
		       var ok:boolean);
procedure schreibe_icon(x1,y1:word;name:string;transparent:boolean;var ok:boolean);

IMPLEMENTATION
USES VGABIOS, GRAPH, CRT;

(*----------------------------------------------------------------------
   WPG-Datei schreiben. 2, 16 oder 256 Farben, normal oder gedreht.
----------------------------------------------------------------------*)
var  wpgaus:File;
     bytefile:file of byte;
     Schreibfehler:Boolean;

procedure bw(s:string);
var soll,ist:word;
begin
  soll:=length(s);
  blockwrite(wpgaus,s[1],length(s),ist);
  Schreibfehler:=soll<>ist;
end;

procedure komprimiere(var b:bytefeldtyp;var l:integer);
{Komprimierung von Bitmapzeilen}
{Bercksichtigt noch keine Folgen von Bytes des Inhalts $FF}
{l ist im Eingang die Nummer des grten Elements,
       im Ausgang die Anzahl komprimierter Bytes}
var i,j,zb,zc:integer;
    c:bytefeldtyp;
begin
  zb:=0; {Zeiger auf gerade angesehenes Byte}
  zc:=0; {Zeiger in komprimierter Zeile}
  REPEAT
    if  (b[zb]=b[1+zb]) then
      {Gleiche Bytes}
      begin
	i:=2;    {Zhler gleicher Bytes}
	j:=l-zb+1;
	While
	      (b[zb]=b[i+zb])
	  and (i<127)
	  and (i<j)
	do inc(i);
	c[zc]:=i or 128;
	c[zc+1]:=b[zb];
	inc(zb,i);
	inc(zc,2);
      end
    ELSE
      begin
	i:=1;    {Zhler unterschiedlicher Bytes}
	j:=l-zb+1;
	While
	  (   (b[zb+i]<>b[zb+i+1])    {Damit nicht fr zwei gleiche Bytes}
	   or (b[zb+i+1]<>b[zb+i+2])) {die Kette unterbrochen wird}
	  and (i<127)
	  and (i<j)
	do inc(i);
	c[zc]:=i;
	move(b[zb],c[zc+1],i);
	inc(zb,i);
	inc(zc,i+1);
      end
  UNTIL zb>l;
  l:=zc;  {Der Zeiger auf das erste freie Feld entspricht der wahren Lnge}
  move(c,b,l);
end; {Komprimiere}


Procedure MonoPack(var b:bytefeldtyp;var l:integer;offset:integer);
var i,i8:integer;k:byte;
begin
inc(l); {Wahre Anzahl}
{Auffllen des letzten Bytes mit wei}
for i:=l to l+(8-(l-offset-1)mod 8) do b[i]:=1;
l:=(l-offset-1) div 8+offset;
for i:=offset to l do
begin
  k:=0;
  i8:=8*(i-offset)+offset;
  k:=     byte(b[i8]<>0)shl 7;inc(i8);
  k:=k or byte(b[i8]<>0)shl 6;inc(i8);
  k:=k or byte(b[i8]<>0)shl 5;inc(i8);
  k:=k or byte(b[i8]<>0)shl 4;inc(i8);
  k:=k or byte(b[i8]<>0)shl 3;inc(i8);
  k:=k or byte(b[i8]<>0)shl 2;inc(i8);
  k:=k or byte(b[i8]<>0)shl 1;inc(i8);
  k:=k or byte(b[i8]<>0);
  b[i]:=k;
end;
end; {Monopack}

Procedure HexPack(var b:bytefeldtyp;var l:integer);
var i:word;
begin
inc(l); {Wahre Anzahl}
{Auffllen des letzten Bytes mit wei}
if odd(l) then b[l]:=15;

l:=(l-1) div 2;
for i:=0 to l do
begin
  b[i]:=16*b[2*i]+(15 and b[2*i+1]);
end;
end; {Hexpack}

FUNCTION BMzeilegleich(var a:bytefeldtyp;la:Word;
			 var b:Bytefeldtyp;lb:word):Boolean;
BEGIN
  if la<>lb then BMzeilegleich:=False else
BEGIN
  la:=0;
  while (la<lb) and (a[la]=b[la]) do inc(la);
  BMZeileGleich:=(la=lb);
END
END;

procedure schreibe_fenster(Modus:Byte;
			   maxfarbe,x1,x2,y1,y2,breitenfaktor:longint;
			   name:Pathstr;monochrom:Boolean;
			   var ok:Boolean);
Label Fehler;
var wpg:file;
    bytefile:file of byte;
      b,altb:bytefeldtyp;
      i,j,k,GleicheZeilen:byte;
      xa,ya:word;
      xl,altxl,
      x,y,
      w:integer;
      bmb,bmh:word;
      bml:longint;       {Bitmaplnge wie eingetragen}
      bmlpos:word;
      RevSortPalette,
      SortPalette:Array[Byte] of Byte;
      RGrauPalette:Array[Byte] of Real;
      rx,gx,bx:BYTE;


begin
  ok:=FALSE;
  If Monochrom and (Modus in [WPG_Grau,WPG_Sortiert]) then goto Fehler;
  Schreibfehler:=False;
  assign(wpgaus,name);
  {erase(wpgaus);}
  if ioresult=0 then;
  rewrite(wpgaus,1); if ioresult<>0 then goto fehler;
  bw(#255'WPC'#16#0#0#0#1#22#1#0#0#0#0#0#15#6#1#0);

  If Modus=WPG_Gedreht Then
  BEGIN
    {Vertausche X und Y}
    y:=y1;
    x:=y2;
    y1:=x1;
    y2:=x2;
    x1:=y;
    x2:=x;
  END;

  If Modus in [WPG_Grau,WPG_Sortiert] then
  begin
  For x:=0 to maxfarbe do
  begin
    SortPalette[x]:=x;
    RGrauPalette[x]:= sqrt(0.01*rofak*RGBPalette[x,1]*RGBPalette[x,1]
			  +0.01*grfak*RGBPalette[x,2]*RGBPalette[x,2]
			  +0.01*blfak*RGBPalette[x,3]*RGBPalette[x,3]);
    if maxfarbe=15 {dann drfen nur Werte von 0..15 in der GrauPalette sein}
    then
      GrauPalette[x]:=Round(RGraupalette[x]) div 16
    else
      GrauPalette[x]:=Round(RGraupalette[x]) and not 3 ;
      {64 Graustufen werden geschrieben, weil mehr auch nicht von
       WordPerfect oder einer VGA-Karte dargestellt werden knnen}
  end;
  end;

  If Modus=WPG_Sortiert then
  BEGIN

    {Bubble-Sort, das Sortieren dauert etwa eine Sekunde:}
    For x:=0 to maxfarbe-1 do
      For y:=maxfarbe downto x+1 do
	if RGraupalette[SortPalette[x]]>RGraupalette[SortPalette[y]]
	then
	begin
	  w:=SortPalette[x];
	  SortPalette[x]:=SortPalette[y];
	  SortPalette[y]:=w;
	end;


    {Fr die bersetzung der Bildpunkte brauche ich die
     Umkehrabbildung der sortierten Palette}
    {y ist die Position der Pixelfarbe x in der neuen Palette}

    For x:=0 to maxfarbe do
    BEGIN
      rx:=rgbpalette[x,1];
      gx:=rgbpalette[x,2];
      bx:=rgbpalette[x,3];
      k:=sortpalette[y];

      y:=-1;
      REPEAT
	inc(y);
	k:=sortpalette[y];
      UNTIL (rx=rgbpalette[k,1]) and
	    (gx=rgbpalette[k,2]) and
	    (bx=rgbpalette[k,3]);
      RevSortPalette[x]:=y;
    END;
  END; {WPG_Sortiert}


  bmb:=x2-x1+1;
  bmh:=y2-y1+1;
  bml:=10; {Wird noch lnger}

  If Modus=WPG_Gedreht Then
    GetAspectRatio(ya,xa)
  ELSE
    GetAspectRatio(xa,ya);

  w:=longint(bmb)*xa div breitenfaktor * 1200 div DPI;
  blockwrite(wpgaus,w,2);     {Breite}
  w:=longint(bmh)*ya div 10000 * 1200 div DPI;
  blockwrite(wpgaus,w,2);     {Hhe}

  {Palette}
  If Monochrom then
    {Sparpalette mit Schwarz und wei}
    bw(#14#10#0#0#2#0#0#0#0#255#255#255)
  else
  if maxfarbe=15 then
    bw(#14#52#0#0#16#0)
  else
    bw(#14#255#4#3#0#0#0#1);

  IF not Monochrom Then
    IF Modus in [WPG_Normal,WPG_Gedreht] then
      blockwrite(wpgaus,rgbpalette,3*(Maxfarbe+1))
    ELSE
      If Modus=WPG_Sortiert then
	for x:=0 to maxfarbe do
	bw(char(RGBpalette[SortPalette[x],1])
	  +char(RGBpalette[SortPalette[x],2])
	  +char(RGBpalette[SortPalette[x],3]))
      ELSE {If Modus=WPG_Grau THEN}
	if maxfarbe=15 then
	  for x:=0 to 15 do bw(char(x*17)+char(x*17)+char(x*17))
	else
	  for x:=0 to 255 do bw(char(x)+char(x)+char(x));


  bw(#11#255'TILT'); {Hier kommt die wahre Lnge noch hin}
  bmlpos:=filepos(wpgaus)-4;

  blockwrite(wpgaus,bmb,2);
  blockwrite(wpgaus,bmh,2);
  if monochrom then
    bw(#1#0#44#1#44#1)      {Bits pro Pixel; Pixel pro Zoll x,y (300)}
  else
  if maxfarbe=15 then
    bw(#4#0#44#1#44#1)
  else
    bw(#8#0#44#1#44#1);

  GleicheZeilen:=0;
  AltXl:=-1;       {Ist eigentlich nur ein Flag fr die erste Zeile,
		   damit die sich nicht wiederholt glaubt}

  for y:=y1 to y2 do
  begin
    CASE Modus of
      WPG_Sortiert:
	for x:=x1 to x2 do b[x-x1]:=Revsortpalette[getpixel(x,y)];
      WPG_Grau:
	for x:=x1 to x2 do b[x-x1]:=graupalette[getpixel(x,y)];
      WPG_Gedreht:
	for x:=x1 to x2 do b[x-x1]:=getpixel(y2+y1-y,x);
      ELSE
	IF (getmaxcolor=255) or (monochrom and (getmaxcolor<>255))
	THEN
	BEGIN
	  getimage(x1,y,x2,y,b);
	  move(b[4],b[0],x2-x1+1);
	END
	ELSE
	  for x:=x1 to x2 do b[x-x1]:=getpixel(x,y);
    END;
    xl:=x2-x1;
    if monochrom and (getmaxcolor=255) then monopack(b,xl,0)
    else if (maxfarbe=15) and not monochrom then HexPack(b,xl)
    else if monochrom then xl:=(x2-x1) div 8;
    komprimiere(b,xl);
    if BMzeilegleich(b,xl,altb,altxl) and (gleichezeilen<255) then
      inc(gleichezeilen)
    else
    begin
      if gleichezeilen<>0 then
      BEGIN
	altb[0]:=0;
	altb[1]:=gleichezeilen;
	blockwrite(wpgaus,altb,2);
	If ioresult<>0 then goto fehler;
	inc(bml,2);
      END;
      move(b,altb,xl);
      altxl:=xl;
      gleichezeilen:=0;
      blockwrite(wpgaus,b,xl);
      If ioresult<>0 then goto fehler;
      inc(bml,xl);
    end;
  end; {for y:=...}

  {Sind ganz am Ende noch ein paar Zeilen zu wiederholen?}
  if gleichezeilen<>0 then
    BEGIN
      altb[0]:=0;
      altb[1]:=gleichezeilen;
      blockwrite(wpgaus,altb,2);
      If ioresult<>0 then goto fehler;
      inc(bml,2);
    END;

  bw(#16#0); {ENDWPG}
  close(wpgaus);
  If ioresult<>0 then goto fehler;

  {Jetzt noch die Lnge nachtragen}
  assign(bytefile,name);
  reset(bytefile);
  If ioresult<>0 then goto fehler;
  seek(bytefile,bmlpos);
  w:=trunc(bml/65536) + $8000;
  i:=lo(w);j:=hi(w);
  write(bytefile,i);  write(bytefile,j);
  If ioresult<>0 then goto fehler;
  w:=bml;
  i:=lo(w);j:=hi(w);
  write(bytefile,i);  write(bytefile,j);
  If ioresult<>0 then goto fehler;
  close(bytefile);
  If ioresult<>0 then goto fehler;
  ok:=TRUE;
EXIT;
Fehler:
  close(wpgaus);if ioresult=0 then;
  close(bytefile);if ioresult=0 then;
  Sound(50);
  ok:=FALSE;
  delay(1000);
  nosound;
end {Schreibe_Fenster};


(*----------------------------------------------------------------------
   WPG-Datei schreiben. 200 % gezoomt mit Farbnummerninterpolation.
----------------------------------------------------------------------*)

procedure schreibe_zoomfenster(maxfarbe,x1,x2,y1,y2,breitenfaktor:longint;
			       name:string;var ok:Boolean);
Label Fehler;
var   b,zwischenb,vorb:bytefeldtyp;
      i,j,k:byte;
      xa,ya:word;
      xl,altxl,
      x,y,
      w:integer;
      bmb,bmh:word;
      bml:longint;       {Bitmaplnge wie eingetragen}
      bmlpos:word;

begin
  Schreibfehler:=False;
  assign(wpgaus,name);
  erase(wpgaus); if ioresult=0 then;
  rewrite(wpgaus,1); if ioresult<>0 then goto fehler;
  bw(#255'WPC'#16#0#0#0#1#22#1#0#0#0#0#0#15#6#1#0);

  bmb:=2*(x2-x1)+1;
  bmh:=2*(y2-y1)+1;
  bml:=10; {Wird noch lnger}

  getaspectratio(xa,ya);
  w:=round(1.0*bmb*1200/DPI*xa/breitenfaktor);
  blockwrite(wpgaus,w,2);     {Breite}
  w:=round(1.0*bmh*1200/DPI*ya/10000);
  blockwrite(wpgaus,w,2);     {Hhe}

  {Palette}
  if maxfarbe=15 then
  begin
    bw(#14#52#0#0#16#0);
    blockwrite(wpgaus,rgbpalette,3*16);
  end
  else
  begin {256er Palette}
    bw(#14#255#4#3#0#0#0#1);
    blockwrite(wpgaus,rgbpalette,3*256);
  end; {Palette}

  bw(#11#255'TILT'); {Hier kommt die wahre Lnge noch hin}
  bmlpos:=filepos(wpgaus)-4;


  blockwrite(wpgaus,bmb,2);
  blockwrite(wpgaus,bmh,2);
  if maxfarbe=15 then
    bw(#4#0#44#1#44#1)
  else
    bw(#8#0#44#1#44#1);

  for y:=y1 to y2 do
  begin
    for x:=x1 to x2 do
    begin
      b[2*(x-x1)]:=getpixel(x,y);
    end;
    for x:=0 to x2-x1 do
    begin
      w:=2*x;
      b[w+1]:=(b[w]+b[w+2]+random(2))div 2;
    end;
    for x:=0 to (x2-x1) do
    begin
      w:=2*x;
      zwischenb[w]  :=(b[w]+vorb[w]+random(2))div 2;
      zwischenb[w+1]:=(b[w]+b[w+2]+vorb[w]+vorb[w+2]
		       +1+random(2))div 4;
    end;
    if y<>y1 then
    begin
      xl:=bmb-1;
      if maxfarbe=15 then HexPack(zwischenb,xl);
      komprimiere(zwischenb,xl);
      blockwrite(wpgaus,zwischenb,xl);
      If ioresult<>0 then goto fehler;
      inc(bml,xl);
    end;
    vorb:=b;
    xl:=bmb-1;
    if maxfarbe=15 then HexPack(b,xl);
    komprimiere(b,xl);
    blockwrite(wpgaus,b,xl);
    If ioresult<>0 then goto fehler;
    inc(bml,xl);
  end;

  bw(#16#0); {ENDWPG}
  close(wpgaus);
  If ioresult<>0 then goto fehler;

  {Jetzt noch die Lnge nachtragen}
  assign(bytefile,name);
  reset(bytefile);
  If ioresult<>0 then goto fehler;
  seek(bytefile,bmlpos);
  w:=trunc(bml/65536) + $8000;
  i:=lo(w);j:=hi(w);
  write(bytefile,i);  write(bytefile,j);
  If ioresult<>0 then goto fehler;
  w:=bml;
  i:=lo(w);j:=hi(w);
  write(bytefile,i);  write(bytefile,j);
  If ioresult<>0 then goto fehler;
  close(bytefile);
  If ioresult<>0 then goto fehler;
  ok:=TRUE;
EXIT;
Fehler:
  close(wpgaus);if ioresult=0 then;
  close(bytefile);if ioresult=0 then;
  Sound(50);
  ok:=FALSE;
  delay(1000);
  nosound;
  readkey;
end {Schreibe_ZoomFenster};

(*----------------------------------------------------------------------
   WPG-Datei schreiben. 50 % gezoomt mit Farbwertinterpolation.
----------------------------------------------------------------------*)

procedure schreibe_viertelfenster(maxfarbe,x1,x2,y1,y2,breitenfaktor:longint;
			       name:string;var ok:Boolean);
Label Fehler;
var
      b:bytefeldtyp;
      i,j,k: Byte;
      xl,
      x,y,
      w:integer;
      xa,ya,
      bmb,bmh:word;
      bml:longint;       {Bitmaplnge wie eingetragen}
      bmlpos:word;

begin
  Schreibfehler:=False;
  assign(wpgaus,name);
  erase(wpgaus); if ioresult=0 then;
  rewrite(wpgaus,1); if ioresult<>0 then goto fehler;
  bw(#255'WPC'#16#0#0#0#1#22#1#0#0#0#0#0#15#6#1#0);

  if not odd(x2-x1) then inc(x2); {Gerade Anzahl Pixel (Differenz ungerade)}
  if not odd(y2-y1) then inc(y2);
  bmb:=(x2-x1+1)div 2;
  bmh:=(y2-y1+1)div 2;
  bml:=10; {Wird noch lnger}

  getaspectratio(xa,ya);
  w:=round(1.0*bmb*1200/DPI*xa/breitenfaktor);
  blockwrite(wpgaus,w,2);     {Breite}
  w:=round(1.0*bmh*1200/DPI*ya/10000);
  blockwrite(wpgaus,w,2);     {Hhe}

  {Palette}
  if maxfarbe=15 then
  begin
    bw(#14#52#0#0#16#0);
    blockwrite(wpgaus,rgbpalette,3*16);
  end
  else
  begin {256er Palette}
    bw(#14#255#4#3#0#0#0#1);
    blockwrite(wpgaus,rgbpalette,3*256);
  end; {Palette}

  bw(#11#255'TILT'); {Hier kommt die wahre Lnge noch hin}
  bmlpos:=filepos(wpgaus)-4;

  blockwrite(wpgaus,bmb,2);
  blockwrite(wpgaus,bmh,2);
  if maxfarbe=15 then
    bw(#4#0#44#1#44#1)
  else
    bw(#8#0#44#1#44#1);

  y:=y1;
  while y<y2 do
  begin
    x:=x1;
    w:=0;
    while x<=x2 do
    begin
      b[w]:=(getpixel(x,y)
	    +getpixel(x+1,y)
	    +getpixel(x,y+1)
	    +getpixel(x+1,y+1)
	    +2)div 4;
      inc(w);
      inc(x,2);
    end;
    xl:=bmb-1;
    if maxfarbe=15 then HexPack(b,xl);
    komprimiere(b,xl);
    blockwrite(wpgaus,b,xl);
    If ioresult<>0 then goto fehler;
    inc(bml,xl);
    inc(y,2);
  end;

  bw(#16#0); {ENDWPG}
  close(wpgaus);
  If ioresult<>0 then goto fehler;

  {Jetzt noch die Lnge nachtragen}
  assign(bytefile,name);
  reset(bytefile);
  If ioresult<>0 then goto fehler;
  seek(bytefile,bmlpos);
  w:=trunc(bml/65536) + $8000;
  i:=lo(w);j:=hi(w);
  write(bytefile,i);  write(bytefile,j);
  If ioresult<>0 then goto fehler;
  w:=bml;
  i:=lo(w);j:=hi(w);
  write(bytefile,i);  write(bytefile,j);
  If ioresult<>0 then goto fehler;
  close(bytefile);
  If ioresult<>0 then goto fehler;
  ok:=TRUE;
EXIT;
Fehler:
  close(wpgaus);if ioresult=0 then;
  close(bytefile);if ioresult=0 then;
  Sound(50);
  ok:=FALSE;
  delay(1000);
  nosound;
  readkey;
end {Schreibe_ViertelFenster};

(*----------------------------------------------------------------------
  DXF-Datei schreiben. Monochrom als Scanzeilen, farbig als 3D-Masche.
----------------------------------------------------------------------*)

procedure schreibe_dxf(x1,x2,y1,y2:word;name:string;
		       monochrom:boolean; var ok:boolean);
label fehler;
const nl=#13#10;
var dxf:text;
    x,xa,y:word;
    pendown:Boolean;

begin
  assign(dxf,name);
  erase(dxf); if ioresult=0 then;
  rewrite(dxf); If ioresult<>0 then goto fehler;
  writeln(dxf,0,nl,'SECTION',nl,2,nl,'HEADER',
	   nl,9,nl,'$LIMMIN',nl,10,nl,0,nl,20,nl,0,
	   nl,9,nl,'$LIMMAX',nl,10,nl,x2-x1,nl,20,nl,y2-y1,
	   nl,0,nl,'ENDSEC');
  If ioresult<>0 then goto fehler;

  writeln(dxf,0,nl,'SECTION',nl,2,nl,'ENTITIES');
  If ioresult<>0 then goto fehler;

  if monochrom then
  begin {Linien}
    pendown:=False;
    for y:=y1 to y2 do
      begin
	for x:=x1 to x2 do
	  if getpixel(x,y)=0 {ZEIGWPG stellt schwarz auf wei dar.}
	  then
	    begin
	    If not Pendown
	    then
	      begin
		pendown:=true;
		xa:=x-x1;
	      end;
	    end
	  else
	   If Pendown
	   then
	     begin
	       pendown:=FALSE;
	       writeln(dxf,0,nl,'LINE',nl,
			   8,nl,'WPG',nl,
			   10,nl,xa,nl,
			   20,nl,y2-y,nl,
			   11,nl,x-x1,nl,
			   21,nl,y2-y);
	       If ioresult<>0 then goto fehler;
	     end;
      {Ende einer Zeile}
      If Pendown
      then
	begin
	  pendown:=FALSE;
	  writeln(dxf,0,nl,'LINE',nl,
		      8,nl,'WPG',nl,
		      10,nl,xa,nl,
		      20,nl,y2-y,nl,
		      11,nl,x-x1+1,nl,
		      21,nl,y2-y);
	  If ioresult<>0 then goto fehler;
	end;
      end; {Zeile}
  end {Linien}
  else
  begin {3D-Masche}
    writeln(dxf,
	      0,nl,'POLYLINE',nl,8,nl,
	      'WPG',nl,66,nl,1,nl,10,nl,0,nl,20,nl,0,nl,30,nl,0,nl,70,nl,
	      16,nl,71,nl,x2-x1+1,nl,72,nl,y2-y1+1);
    If ioresult<>0 then goto fehler;

    for x:=x1 to x2 do
      for y:=y2 downto y1 do
	begin
	writeln(dxf,0,nl,'VERTEX',nl,8,nl,'WPG',nl,10,nl,x-x1,nl,20,nl,
		    y2-y,nl,30,nl,getpixel(x,y),nl,70,nl,64);
	If ioresult<>0 then goto fehler;
	end;

    writeln(dxf,0,nl,'SEQEND',nl,8,nl,0);
    If ioresult<>0 then goto fehler;
  end; {3D-Masche}
  writeln(dxf,0,nl,'ENDSEC',nl,0,nl,'EOF');
  If ioresult<>0 then goto fehler;
  close(dxf);
  If ioresult<>0 then goto fehler;
  ok:=True;
EXIT;
Fehler:
  close(DXF);if ioresult=0 then;
  Sound(50);
  ok:=False;
  delay(1000);
  nosound;
  readkey;
end {Schreibe_DXF};

(*----------------------------------------------------------------------
  HPGL-Datei schreiben. Monochrom als Scanzeilen.
----------------------------------------------------------------------*)

procedure schreibe_HPGL(x1,x2,y1,y2:word;name:string;
		       var ok:boolean);
label fehler;
var PLT:text;
    x,xa,y:word;
    pendown:Boolean;

begin
  assign(PLT,name);
  erase(PLT); if ioresult=0 then;
  rewrite(PLT); If ioresult<>0 then goto fehler;
  writeln(plt,'IN;SP1;LT;PU;');
  If ioresult<>0 then goto fehler;
  pendown:=False;
  for y:=y1 to y2 do
    begin
      for x:=x1 to x2 do
	if getpixel(x,y)<>HGFarbe
	then
	  begin
	  If not Pendown
	  then
	    begin
	      pendown:=true;
	      xa:=x-x1;
	    end;
	  end
	else
	 If Pendown
	 then
	   begin
	     pendown:=FALSE;
	     Write(PLT,'PU',xa,',',y2-y,'PD',x-x1,',',y2-y,';');
	     If ioresult<>0 then goto fehler;
	   end;
    {Ende einer Zeile}
    If Pendown
    then
      begin
	pendown:=FALSE;
	Write(PLT,'PU',xa,',',y2-y,'PD',x-x1+1,',',y2-y,';');
	If ioresult<>0 then goto fehler;
      end;
    Writeln(PLT);
    end; {For... Zeile}
  writeLN(plt,'PU;PA0,0;SP;');
  If ioresult<>0 then goto fehler;
  close(PLT);
  If ioresult<>0 then goto fehler;
  ok:=True;
EXIT;
Fehler:
  close(PLT);if ioresult=0 then;
  Sound(50);
  ok:=False;
  delay(1000);
  nosound;
  readkey;
end {Schreibe_HPGL};

(*----------------------------------------------------------------------
		 PCX-Datei schreiben.
----------------------------------------------------------------------*)

procedure Schreibe_PCX(x1,x2,y1,y2:word;name:string;
		       monochrom:boolean;var ok:boolean);
label fehler;
var PCX:FILE;
    Zeile,PZ:Bytefeldtyp;
    y,bpz,bppz:integer;
    iml4:integer;
    Farbebenen:integer;

    procedure bw(s:string);
    begin
      blockwrite(pcx,s[1],length(s));
    end;

    procedure packzeile(offset:integer);
    var	ia,
	iz,
	bis,
	zaehler:integer;
	last:byte;
    begin
      ia:=0;
      iz:=offset;
      last:=Zeile[iz];
      bis:=offset+bpz;
      while iz<bis do
      begin
	last:=Zeile[iz];
	Zaehler:=1;
	while (Zaehler<63)
	  and (Zeile[iz+Zaehler]=last)
	  and (iz+zaehler<bis)
	  do inc(Zaehler);
	If (Zaehler>1) or (Last>=$C0)
	then
	begin
	PZ[ia]:=$C0 or Zaehler;
	inc(ia);
	end;
	PZ[ia]:=Last;
	inc(ia);
	inc(iz,Zaehler);
      end;
      pz[ia]:=0;
      bppz:=ia;
    end;
begin
  ok:=false;
  assign(pcx,name);
  erase(pcx); if ioresult=0 then;
  rewrite(pcx,1); If ioresult<>0 then goto fehler;

  if monochrom then bw(#10#3#1#1)
  else
  case getmaxcolor of
    15: bw(#10#5#1#1);
   255: bw(#10#5#1#8);
   else goto fehler;
  end;
  If ioresult<>0 then goto fehler;
  bw(#0#0#0#0);
  y:=x2-x1;
  blockwrite(PCX,y,2);
  y:=y2-y1;
  blockwrite(PCX,y,2);

  bw(#44#1#44#1);
  blockwrite(PCX,RGBPalette,48);
  if (getmaxcolor=15) and not monochrom
  then Farbebenen:=4
  else Farbebenen:=1;
  bw(#0+char(farbebenen));

  if (getmaxcolor=255) and not monochrom then
    bpz:=((x2-x1)+1)
  else
    bpz:=((x2-x1)+1+7) div 8;

  blockwrite(PCX,bpz,2);
  bpz:=bpz*Farbebenen; {Zeilenbergreifende Komprimierung}
  {Textkonstante darf maximal 58 Byte lang sein}
  bw(#1#0' This Graphic was created using '+Programmname+' ');
  {Sicherheitshalber...}
  seek(PCX,128);

  if getmaxcolor=15 then
  if monochrom then
  for y:=y1 to y2 do
  begin
    iml4:=(imagesize(x1,y,x2,y)-4)div 4;
    getimage(x1,y,x2,y,Zeile);
    PackZeile(4+3*iml4);
    blockwrite(PCX,PZ,bppz);If ioresult<>0 then goto fehler;
  end
  else {16-farbiges PCX}
  for y:=y1 to y2 do
  begin
    iml4:=(imagesize(x1,y,x2,y)-4)div 4;
    getimage(x1,y,x2,y,PZ);
    move(PZ[4],Zeile[3*iml4],iml4);
    move(PZ[4+iml4],Zeile[2*iml4],iml4);
    move(PZ[4+2*iml4],Zeile[iml4],iml4);
    move(PZ[4+3*iml4],Zeile[0],iml4);
    PackZeile(0);
    blockwrite(PCX,PZ,bppz);If ioresult<>0 then goto fehler;
  end
  else {getmaxcolor<>15}
  for y:=y1 to y2 do
  begin
    getimage(x1,y,x2,y,Zeile);
    if (getmaxcolor=255) and monochrom then
    begin
      bpz:=x2-x1+4; {Offset fr GetImage-Koordianten}
      monopack(Zeile,bpz,4);
      dec(bpz,3);   {Offset}
    end;
    PackZeile(4);
    blockwrite(PCX,PZ,bppz);
    If ioresult<>0 then goto fehler;
  end;

  if (getmaxcolor=255) and not monochrom then
  begin
    bw(#12); {Palettenkennung}
    blockwrite(PCX,RGBPalette,3*256);
    If ioresult<>0 then goto fehler;
  end;
  CLOSE(PCX);
  If ioresult<>0 then goto fehler;
  ok:=True;
EXIT;
Fehler:
  close(PCX);if ioresult=0 then;
  Sound(50);
  ok:=False;
  delay(1000);
  nosound;
  readkey;
end {Schreibe_PCX};

(*----------------------------------------------------------------------
		 Quick-Window-Grafik-Datei schreiben.
----------------------------------------------------------------------*)

procedure Schreibe_QWG(x1,x2,y1,y2:word;name:string;
		       var ok:boolean);
label fehler;
var QWG:FILE;
    Zeile:Bytefeldtyp;
    y,bpz:integer;

    procedure bw(s:string);
    begin
      blockwrite(QWG,s[1],length(s));
    end;
begin
  ok:=false;
  assign(QWG,name);
  erase(QWG); if ioresult=0 then;
  rewrite(QWG,1); If ioresult<>0 then goto fehler;

  bw('MV');
  y:=GetMaxColor;
  blockwrite(QWG,y,2);
  y:=x2-x1;
  blockwrite(QWG,y,2);
  y:=y2-y1;
  blockwrite(QWG,y,2);

  case getmaxcolor of
     1: bpz:=((x2-x1)+1+7) div 8;
    15: bpz:=(((x2-x1)+1+7) div 8)*4;
   255: bpz:=((x2-x1)+1);
  end;
  if odd(bpz) then inc(bpz);
  blockwrite(QWG,bpz,2);
  bw(#0#0#0#0#0#0); {6 Byte}

  for y:=y1 to y2 do
  begin
    getimage(x1,y,x2,y,Zeile);
    blockwrite(QWG,Zeile[4],bpz);If ioresult<>0 then goto fehler;
  end;
  CLOSE(QWG);
  If ioresult<>0 then goto fehler;
  ok:=True;
EXIT;
Fehler:
  close(QWG);if ioresult=0 then;
  Sound(50);
  ok:=False;
  delay(1000);
  nosound;
  readkey;
end {Schreibe_QWG};

(*----------------------------------------------------------------------
	       Windows-ICON schreiben. Immer 32x32x16.
----------------------------------------------------------------------*)

procedure schreibe_icon(x1,y1:word;name:string;transparent:Boolean;var ok:boolean);

{ Ein Icon besteht aus einem 61 Byte groen Header, ber dessen
  Aufbau ich berhaupt nichts wei. Die Konstante Iconheader ist
  schlicht aus einem existierenden Icon abgeguckt.

  Danach folgen 16 Paletteneintrge, die je 4 Byte Gre haben.
  Ihre Reihenfolge ist B,G,R,x. B, G, und R sind gltig von
  0..255, x ist immer null.

  Anschlieend 32*32 Punkte mit 4 Bit pro Punkt. Ein Icon wird
  von unten nach oben aufgebaut.

  Schlielich noch eine 128 Byte groe Bitmaske, mit der der
  Hintergrund ausmaskiert werden kann. Zu setzende Punkte haben
  eine 1, auszumaskierende Punkte eine 0, wenn der Hintergrund
  schon auf 0 ist. Wenn nicht, scheint es etwas kompliziert
  zu sein.
}


label fehler;
var icon:file;
    x,y,i:word;
    zeile:array[0..15] of Byte;
    maske:array[0..31,0..1] of word;

const iconheader:array[0..61]of byte=
       (0,0,1,0,  {ICON-Kennung}
	1,0,      {1 Bild}
	32,       {x-Auflsung}
	32,       {y-Auflsung}
	16,0,     {Farbzahl}
	0,0,      {"Bits pro Pixel", n.v.}
	0,0,      {"Farbebenen", n.v.}
	232,2,0,0,{Speicherbedarf ohne die 22 Byte Header (744)}
	22,0,0,0, {Dateiposition des BitMaps (gleich hinter dem Header)}

	40,0,0,0, {BitMap-Gre (?)}
	32,0,0,0, {Breite}
	64,0,0,0, {Hhe} {Wenn hier 32 steht, gibt's manchmal Gemse...}
	1,0,      {Planes}
	4,0,      {Bit pro Farbe}
	0,0,0,0,  {Kompression}
	128,2,0,0,{Gre in Byte (512+128)}
	0,0,0,0,  {X Pixel pro Meter}
	0,0,0,0,  {Y Pixel pro Meter}
	0,0,0,0,  {"ClrUsed"}
	0,0,0,0   {"ClrImportant"}
	);

function gp(x,y:word):byte;
var g:byte;
begin
  g:=getpixel(x,y);
  if transparent and (g=hgfarbe) then gp:=0 else gp:=g;
end;

begin
  if ioresult=0 then;
  assign(icon,name);
  erase(icon); if ioresult=0 then;
  rewrite(icon,1); If ioresult<>0 then goto fehler;

  blockwrite(icon,iconheader,sizeof(iconheader));if ioresult<>0 then goto fehler;

  i:=0;
  for x:=0 to 15 do
  begin
    blockwrite(icon,rgbpalette[x,3],1);if ioresult<>0 then goto fehler;
    blockwrite(icon,rgbpalette[x,2],1);if ioresult<>0 then goto fehler;
    blockwrite(icon,rgbpalette[x,1],1);if ioresult<>0 then goto fehler;
    blockwrite(icon,i,1);if ioresult<>0 then goto fehler;
  end;

  for y:=y1+31 downto y1 do
  begin
    for i:=0 to 15 do
      zeile[i]:=gp(x1+2*i,y)*16+gp(x1+2*i+1,y)and 15;
    blockwrite(icon,zeile,16);if ioresult<>0 then goto fehler;
  end;

  x:=0;
  fillchar(maske,128,#0);
  if transparent then
  for y:=y1+31 downto y1 do
  begin
    for i:=0 to 15 do
    begin
      if getpixel(x1+i,y)=hgfarbe
	then maske[x,0]:=maske[x,0] or (1 shl (15-i));
      if getpixel(x1+i+16,y)=hgfarbe
	then maske[x,1]:=maske[x,1] or (1 shl (15-i));
    end;
    maske[x,0]:=swap(maske[x,0]);
    maske[x,1]:=swap(maske[x,1]);
    inc(x);
  end;

  blockwrite(icon,maske,128);if ioresult<>0 then goto fehler;

  close(icon); if ioresult<>0 then goto fehler;
  ok:=true;
EXIT;
Fehler:
  close(icon);if ioresult=0 then;
  Sound(50);
  ok:=False;
  delay(1000);
  nosound;
  readkey;
end {Schreibe_icon};



BEGIN END.
