{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
unit ICNVIEW;

interface
procedure ZeigWindowsIcon;

implementation
uses
  graph,
  viewprim,
  general,
  crt,
  viewsl;

TYPE
     PPType=Procedure(x,y:Integer;b:word);
	    {Damit nicht bei der Bitmapdarstellung fr jedes Pixel
	     eine Fallunterscheidung gemacht werden mu, gibt es eine
	     Vielzahl von Putpixelvarianten fr jeden Modus.}
     MonoDithlinetyp=ARRAY[-1..1024] of integer;
VAR
    fehler1     :^MonoDithlinetyp;
    fehler2     :^MonoDithlinetyp;
		 {Fr Monochromdithering.}
    xa:Integer; {x-Koordinate des letzten gesetzten Bildpunktes}
    ya:Integer; {y-Koordinate der letzten dargestellten Bildzeile}

(*---------------------------------------------------------------------
		ANZEIGE EINES ICONS
---------------------------------------------------------------------*)


(*---------------------------------------------------------------------
     PROZEDUREN ZUM SETZEN EINES BILDPUNKTES IN VERSCHIEDENEN MODI
---------------------------------------------------------------------*)
  PROCEDURE CBAR(x1,y1,x2,y2,Farbe:Integer);
  BEGIN
    if (x1=x2) and (y1=y2)
    THEN Graph.PutPixel(x1,y1,Farbe)
    ELSE
      BEGIN
	SetFillStyle(SolidFill,farbe);
	bar(x1,y1,x2,y2);
      END;
  END;

{$F+} {Auf diese Prozeduren wird ber Pointer zugegriffen}

  PROCEDURE MonoputFarbe(x,y:Integer;Farbe:Word);
  {Der selbe Algorithmus wie eben}
  VAR f,f4	:integer;
  BEGIN
     if x=xa then exit; {Kann denselben Punkt nicht zweimal setzen.}
     xa:=x;

     if x=0 then
       begin
	 if y<=0 then fillchar(fehler1^,sizeof(fehler1^),#0)
		else fehler1^:=fehler2^;
	 fehler2^[0]:=0;
       end;

     f:=Graupalette[farbe]+fehler1^[x];
     if f>127 then dec(f,255) else graph.putpixel(x,y,0);
     {Wei ist der Hintergrund schon}

     {Die ursprnglichen Befehle stehen im Anhang...}
     {Hier eine krzere Variante:}
     f4:=f div 4;
     inc(fehler1^[x+1],f4);
     fehler2^[x+1]:=f4;
     inc(fehler2^[x],f4);
     inc(fehler2^[x-1],f4);
  END;

  PROCEDURE MonoputFarbe_OD(x,y:Integer;Farbe:Word);
  {Ordered Dithering}
  BEGIN
     if Graupalette[farbe]<=DiMat^[x and 7,y and 7]
     then graph.putpixel(x,y,0);
  END;

  PROCEDURE MonoZoomFarbe(x,y:Integer;Farbe:Byte);
  BEGIN
     SetFillPattern(MonoPattern[GrauPalette[farbe]div 4{17}],getmaxcolor);
     SetFillStyle(UserFill,getmaxcolor);
     bar(succ(xa),succ(ya),x,y);
     xa:=x;
  END;

  PROCEDURE ZoomPutPixel(x,y:Integer;Farbe:Word);
  BEGIN
     Cbar(succ(xa),succ(ya),x,y,Farbe);
     xa:=x;
  END;

{$F-}

procedure ZeigWindowsIcon;
Label Fehler;
type icontyp=record
		Kennung:longint;
		Anzico:Word;
		auflx:Byte;
		aufly:Byte;
		anzfarb:word;
		dummy1:word;
		dummy2:word;
		spbed:longint;
		filepos:longint;
		bisize:longint;
		biwidth:longint;
		biheight:longint;
		biplanes:word;
		bibitcount:word;
		bicompression:longint;
		bisizeimage:longint;
		bixppm:longint;
		biyppm:longint;
		biclrused:longint;
		biclrimportant:longint;
		palette:array[0..15,1..4] of Byte;
		bitmap:array[0..31,0..15] of Byte;
		Maske:array[0..31,0..1] of Word;
	     end;
VAR
  icon:icontyp;
  gelesen,
  n,m,y:word;
  Zeile:Array[0..31] of Byte;
  putpixel:pptype;
  xas,yas:word;
  v1,v2:real;

begin with icon do begin
  if ioresult<>0 then; {Wo kommt das her?!!!}
  blockread(wpg,icon,sizeof(icontyp),gelesen);
  if ioresult<>0 then;

  Falschertyp:=
      (Kennung<>$10000)
   or (Anzico<>1)
   or (bibitcount<>4)
   or (bisizeimage<>512+128);
   {Sollte reichen}

  If Falschertyp then exit;

  If Zeichnungbegonnen and not keypressed then
  {Zeichenflche lschen}
  begin
    setfillstyle(userfill,HGFarbe);
    setfillPattern(HGMuster,HGfarbe);
    bar(0,0,maxx,maxy);
    Zeichnungbegonnen:=FALSE;
  END;

  For n:=0 to 15 do
  begin
    SetRGBPalette(n,palette[n,3],palette[n,2],palette[n,1]);
    if monochrom then graupalette[n]:=grauwert(n);
  end;
  WriteSL(' (Windows-Icon)',FALSE);

  GetAspectRatio(Xas,Yas);
  Xas:=round(Xas*10000.0/Breitenfaktor);

  v1:=1.0*(maxx+1)/32;
  v2:=1.0*(maxy+1)/32*Yas/Xas;
  if v1>v2 then
  BEGIN
    xvaria:=round(v2*Eins);
    yvaria:=round(v2*Xas/Yas*Eins);
  END
  ELSE
  BEGIN
    xvaria:=round(v1*Eins);
    yvaria:=round(v1*Xas/Yas*Eins);
  END;


  If EinsZuEins THEN
  BEGIN
    xvaria:=Eins; {Eins ist $10000, fr meine LongInt-Rundungen}
    yvaria:=Eins;
  END;

  ZoomDiesBitMap:=ZoomBitMap and ((XVaria>Eins) or (YVaria>Eins));

  If Not ZoomDiesBitmap Then
  BEGIN
    if xvaria>Eins then
     begin
       yvaria:=round(1.0*yvaria/xvaria*Eins);
       xvaria:=Eins;
     end;
    if yvaria>Eins then
     begin
       xvaria:=round(1.0*xvaria/yvaria*Eins);
       yvaria:=Eins;
     end;
  END;
{$F+}
  {Welches Schweinderl htten's denn gern?}
  If ZoomDiesBitmap
  Then
    If Monochrom Then
      @PutPixel:=@MonoZoomFarbe
    ELSE
      @PutPixel:=@ZoomPutPixel
  ELSE {Nicht gezoomt:}
    if Monochrom
    then
      if not NimmFloyd
	 then @putpixel:=@MonoPutFarbe_OD
	 else
	   @putpixel:=@MonoPutFarbe
    else {Farbige Darstellung}
      @putpixel:=@graph.putpixel;
{$F-}
  if (@PutPixel=@monoputfarbe) then
	 begin
	   new(fehler1);
	   new(fehler2);
	 end;

  ya:=0;
  for n:=0 to 31 do
  begin
    maske[31-n,0]:=swap(maske[31-n,0]);
    maske[31-n,1]:=swap(maske[31-n,1]);
    for m:=0 to 15 do
    begin
      Zeile[m*2]:=bitmap[31-n,m] div 16;
      Zeile[m*2+1]:=bitmap[31-n,m] and 15
    end;
    for m:=0 to 15 do
    begin
      if (maske[31-n,0] and ($8000 shr m))<>0
      then Zeile[m]:=hgfarbe;
      if (maske[31-n,1] and ($8000 shr m))<>0
      then Zeile[m+16]:=hgfarbe;
    end;
    y:=hiword((n+1)*yvaria)-1;
    xa:=-1;
    if not keypressed then
    for m:=0 to 31 do
      putpixel(hiword((m+1)*xvaria)-1,y,zeile[m]);
    ya:=y;
  end;
  ZeichnungBegonnen:=not ineinanderzeichnen;
  if (@PutPixel=@monoputfarbe) then
	 begin
	   dispose(fehler1);
	   dispose(fehler2);
	 end;
end end;

begin end.

