{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
{G und S ber IDE}
unit PCXVIEW;

interface uses crt,dos,graph,vgabios,viewprim,general,viewsl,popwin,qwgio;
type pcxheadertyp=Record
       id:byte; 	{10=PCX} {205=SCR}
       version:byte;    {0=2.5, 2=2.8 m.Pal, 3=2.8 o.Pal, 5=3.0}
       rle:byte;        {1=RLE-Kompression}
       bipp:Byte;	{Bits pro Pixel}
       xmin,
       ymin,
       xmax,
       ymax:Word;	{Fensterkoordinaten}
       xdpi,
       ydpi:Word;	{Auflsung}
       pal:array[0..15,1..3] of Byte;
       reserviert:Byte;
       Farbebenen:Byte;	{1 oder 4}
       BpZ:Word;	{Gerade Anzahl Bytes pro Bildzeile}
       PalTyp:Word;	{1=Mono/Col, 2=Grau}
       Muell:Array[1..58] of Byte;
     end;

procedure liespcx;

implementation

  PROCEDURE InitGrau16;
  var i:byte;
      zvF:Boolean;
  BEGIN
    zvf:=ZuvieleFarben;
    ZuVieleFarben:=False;
    FOR i:=0 to 15 do
      SETRGBPalette(i,17*i,17*i,17*i);  {Schwarz}
    ZuVieleFarben:=zvF;
  END;

(*---------------------------------------------------------------------
	  4 Monochrome Zeilen nach 16 Graustufen
---------------------------------------------------------------------*)


Procedure Monomachgrau(y:Integer;Zeile:Bytefeldtyp;Laenge:Integer);
VAR M,Y4:Integer;
    C:Byte;
    W:Word;
    m2gzeile    :ARRAY[0..3] of BytefeldTyp;
		 {Fr Mononachgrau}
BEGIN
  move(zeile[0],m2gzeile[y mod 4][0],Laenge);
  if y mod 4 = 3 then
  BEGIN
    Y4:=Y DIV 4;
    for m:=0 to laenge-1 do
    begin
      W:=LRBitSum(M2GZeile[0,m],M2GZeile[1,m],M2GZeile[2,m],M2GZeile[3,m]);
      putpixel(M*2,y4,hi(W));
      putpixel(M*2+1,y4,lo(W));
    end;
  END;
END;

(*---------------------------------------------------------------------
		    Monochrome Zeile nach 256
---------------------------------------------------------------------*)
Procedure BitzuByte(VAR Z:ByteFeldTYP;MonoBytes:integer);
VAR Lauf:Integer;
    c,i:Byte;
    BytePos:integer;
BEGIN
  BytePos:=8*MonoBytes-1;
  For Lauf:=MonoBytes-1 Downto 0 do
  BEGIN
    c:=Z[Lauf];
    for i:=7 downto 0 do
    begin
      if odd(c) then z[BytePos]:=255 else z[Bytepos]:=0;
      c:=c shr 1;
      dec(BytePos);
    end;
  END;
END;



procedure liespcx;
Label Fehler;
var s:string;
var i,j,n:integer;
var header:pcxheadertyp;
var pufpos:longint;
var bpiz:integer; {Byte pro Zeile bei PutImage}
var zeile:bytefeldtyp;
var zeilenzahl:Integer;
var MonoMachGrau_Moeglich:boolean;
var img:record			{Fr PutImage}
	    breite,
	    hoehe:word;
	    zeile:Bytefeldtyp;
	  end;
VAR Puffer:^Puffertyp;
VAR MaxPuffer:Word;

function liesbyte:Byte;
var gelesen:word;
begin
  if pufpos>maxpuffer
  then
   begin
    blockread(wpg,puffer^,maxpuffer,gelesen);
    if ioresult<>0 then;
    pufpos:=1;
   end;
  liesbyte:=puffer^[pufpos];
  inc(pufpos);
end;

PROCEDURE LiesZeile(VAR Z:ByteFeldTyp;Sollaenge:Word);
VAR L,i:Word;
    b:byte;
    b2:byte;
    ppbak:word;
    {Image Alchemy komprimiert die einzelnen Farbebenen nicht
     separat, da kann schon mal eine Zeile in die nchste reichen:}
    const lbak:byte=0;
    const bbak:byte=0;
BEGIN
  L:=Lbak;
  for i:=0 to lbak do z[i]:=bbak;
  Repeat
  b:=liesbyte;
  if b<=192 then
    BEGIN
      Z[L]:=b;
      inc(L);
    END
  ELSE
    BEGIN
      b:=b and 63;
      b2:=liesbyte;
      for i:=l to l+b do Z[i]:=b2;
      inc(l,b);
    END;
  until L>=Sollaenge;
  if l>sollaenge then
  begin
    lbak:=l-sollaenge;
    bbak:=b2;
  end else lbak:=0;
END;

begin {liespcx}
  if ioresult<>0 then;
  seek(wpg,0);
  blockread(wpg,header,128);if ioresult<>0 then goto fehler;
  if (header.id<>10) and (header.id<>205) then goto fehler;
  if (getmaxcolor=255) and (header.Farbebenen=4)
  or (getmaxcolor<>255) and (header.bipp=8)
  or not(header.farbebenen in [1,4])
  or not(header.bipp in [1,8])
  or not(header.version in [0,2,3,5])
  or (header.rle<>1)
  or (header.bpz>2048)
  then
  begin
    Writesl('Diese PCX-Datei kann in diesem Grafikmodus nicht dargestellt werden.',true);
    EXIT;
  end;

  falschertyp:=false;

  If Zeichnungbegonnen and not keypressed and not ineinanderzeichnen then
  begin
    {Zeichenflche lschen}
    setfillstyle(userfill,HGFarbe);
    setfillPattern(HGMuster,HGfarbe);
    bar(0,0,maxx,maxy);
    Zeichnungbegonnen:=FALSE;
  END;

  Setrgbpalette(0,0,0,0);

  MonoMachGrau_Moeglich:= (header.Farbebenen*header.bipp=1)
		      and Graustufen
		      and not monochrom;

  If (header.Farbebenen*header.bipp=1)
  then
    if MonoMachGrau_Moeglich
    then initgrau16
    else SetRGBPalette(1,255,255,255);

  if not (monochrom or graustufen or (header.Farbebenen*header.bipp=1))
  then {Palette benutzen}
  if (header.version=5) and (header.bipp=8)
  then
  begin
    seek(wpg,filesize(wpg)-256*3-1);
    i:=0;
    blockread(wpg,i,1); if ioresult<>0 then i:=0;
    IF i=12 {Tolle Erkennung!}
    THEN
      for j:=0 to 15 do
      begin
	blockread(wpg,header.pal,3*16);
	if ioresult=0 then
	for i:=0 to 15 do
	  setrgbpalette(i+16*j,header.pal[i,1],header.pal[i,2],header.pal[i,3]);
      end
    ELSE
      for i:=0 to 15 do
	setrgbpalette(i,header.pal[i,1],header.pal[i,2],header.pal[i,3]);
    seek(wpg,128);
  end
  ELSE {keine angehngte Palette, kein Monochrommodus, keine Graustufen}
  for i:=0 to 15 do
    setrgbpalette(i,header.pal[i,1],header.pal[i,2],header.pal[i,3]);

  with header do begin
  If Not Infogefunden then
  WriteSL(', '+ls(1+xmax-xmin)+' x '+ls(1+ymax-ymin)+' Punkte',FALSE);

  Maxpuffer:=lmin(maxavail,sizeof(puffertyp));
  getmem(puffer,maxpuffer);
  pufpos:=maxpuffer+1;
  img.hoehe:=0;
  if not monochrom and Graustufen
  then img.breite:=lmin(xmax-xmin,4*maxx)
  else img.breite:=lmin(xmax-xmin,maxx);
  if getmaxcolor=15 then {4 Farbebenen auf der Karte}
    bpiz:=(imagesize(0,0,img.breite,0)-4)div 4
  else
    bpiz:=imagesize(0,0,img.breite,0)-4;

  Zeichnungbegonnen:=NOT Ineinanderzeichnen;
  if not monochrom and Graustufen
  then Zeilenzahl:=lmin(4*maxy,ymax-ymin)
  else Zeilenzahl:=lmin(maxy,ymax-ymin);
  for n:=0 to Zeilenzahl do
  begin
    if (ioresult<>0) or keypressed then
    begin
      FREEMEM(puffer,MAXPUFFER);
      exit;
    end;

    if farbebenen=4 then
    begin
    lieszeile(zeile,header.bpz);
    move(zeile,img.zeile[3*bpiz],bpiz);
    lieszeile(zeile,header.bpz);
    move(zeile,img.zeile[2*bpiz],bpiz);
    lieszeile(zeile,header.bpz);
    move(zeile,img.zeile[bpiz],bpiz);
    lieszeile(zeile,header.bpz);
    move(zeile,img.zeile[0],bpiz);
    end
    else
    lieszeile(img.zeile,header.bpz);

    if not monochrom and graustufen then monomachgrau(n,img.zeile,(img.breite+1) div 8)
    ELSE
    if (HERCULES or EGAVGA16) and (Farbebenen=1)
    THEN
    IF hercules
    {Das Bild ist ja schon bitrichtig fr die Hercules-
     Karte vorhanden. Ab in den Bildspeicher:}
    THEN move(img.Zeile,
	      mem[$b000:hgaddress[n]],
	      (img.breite+1) div 8)
    ELSE {EGAVGA16}
    {Dann ab in die BitPlanes}
	 move(img.Zeile,
	      mem[$a000:n*EGAVGABreite],
	      (img.breite+1) div 8)
    ELSE
    BEGIN
    if (Farbebenen*bipp=1) then
    if (getmaxcolor=15) then
    begin {Zeile vervierfachen, um BitPlanes zu simulieren}
      move(img.zeile[0],img.zeile[bpiz],bpiz);
      move(img.zeile[0],img.zeile[2*bpiz],2*bpiz);
    end
    ELSE
    if (getmaxcolor=255) and (bipp<>8) then
    begin
      BitzuByte(img.zeile,min(header.bpz,(maxx+7) div 8));
    end;
    putimage(0,n,img,copyput);
    END; {Kein direkter Bildspeicherzugriff}
  end; {schleife ber zeilen}
  end; {with header do}
  FREEMEM(puffer,MAXPUFFER);
Exit;
Fehler:
  writesl('Ist keine darstellbare PCX-Datei,',true);
  Falschertyp:=True;
end; {LiesPCX}

begin end.
