{$A+,B-,D+,E+,F+,I-,L+,N+,O+,P-,Q-,R-,T-,V+,X+,Y+}
Unit Script;
{
Interpreter fr eine
Scriptsprache fr interaktive audiovisuelle Anwendungen

Autor:          Martin Vogel
Sprache:        Turbo Pascal 7.0
Betriebssystem: MS-DOS 5.0

(c) 1993 by
    Fachhochschule Bochum
    Fachbereich 2, Bauingenieurwesen
    Dipl.-Ing. Martin Vogel
    Lennershofstr. 140
    44801 Bochum
    Tel 0234-700-4639

ͻ
 Version   Datum                          nderung                        
Ķ
   1.04   18.08.93  Vollstndige Bezeichnung aller Tastaturcodes nach     
                    ASCII                                                 
                                                                          
                    Kommentare auch hinter Sprungzielen erlaubt           
                                                                          
   1.03   09.08.93  Befehle und Tastenbezeichner drfen nun beliebig      
                    viele Zeichen umfassen                                
                                                                          
   1.02   08.07.93  Implementierung GOSUB                                 
                                                                          
   1.01   05.07.93  Implementierung GOTO                                  
                                                                          
   1.00   02.07.93                                                        
ͼ

Am Ende dieser Datei befindet sich ein Anhang mit technischen Erluterungen,
in dem zum Beispiel auch erklrt wird, was eigentlich eine Script-Datei ist.
}

INTERFACE USES DOS,CRT;
CONST {Konstanten}
  {Mgliche Kennungen fr Fehlermeldungen}
  seNoScriptFile      =-1;
  seLabelNotFound     =-2;
  seCallStackOverflow =-3;
  seReturnWithoutGosub=-4;
  seUnknownCommand    =-5;
VAR {Globale Variablen}
  {Prozeduren, die auf eigene Routinen gelegt werden knnen}
  {Eine kurze Erklrung, warum eine Prozedur eine Variable
   sein kann, findet sich im Anhang am Ende dieses Programmtextes}
  ScriptError :Procedure(Errnr,Errln:Integer);
  ScriptExit  :Procedure;
CONST {Vorbelegte Variablen}
  {Diese knnen vom aufrufenden Programm abgefragt und gegebenenfalls
   gendert werden}
  ScriptName  :PathStr='';    {Name der Script-Datei}
  ScriptAktiv :Boolean=FALSE; {TRUE: Script-Datei wird gerade ausgefhrt}

Function OpenScript(sn:Pathstr):Boolean;
  {Script-Datei zur Verarbeitung ffnen}
Function GetFirstScriptPicture:pathstr;
  {Name der ersten Bilddatei eines Scripts}
Function GetNextScriptPicture(key:string):pathstr;
  {Name der nchsten Bilddatei}
Function KeyName(Key1,Key2:Char):String;
  {Name eines Tastendruckes}

(***********************************************************************
                 Ausfhrungsteil der Unit SCRIPT
***********************************************************************)
IMPLEMENTATION
TYPE  {Typen}
  {Namen von Bilddateien}
  PictureType=PathStr;
  {Liste der erlaubten Befehle}
  ScriptCommandType=( scGOTO, scGOSUB,  scRETURN, scEXIT,
                      scBEEP, scUNKNOWN );
CONST {Konstanten}
  {Maximale Anzahl von Unterprogrammebenen}
  PictureStackSize=32;
  {Fr den Zugriff auf schreibgeschtzte Dateien oder im Netz-
   werkbetrieb mssen die Zugriffsrechte bei DOS angemeldet
   werden. Siehe FILEMODE im Anhang}
  fm_read         =  0; {Lesezugriff}
  fm_write        =  1; {Schreibzugriff}
  fm_readwrite    =  2; {Normaler DOS-Zugriff}
  fm_compatibility=  0; {Normaler DOS-Zugriff}
  fm_denyboth     = 16; {Datei fr andere Netzwerkprogramme gesperrt}
  fm_denywrite    = 32; {Datei darf von anderen nicht modifiziert werden}
  fm_denyread     = 48; {Datei wird nicht zum Lesen freigegeben}
  fm_denynon      = 64; {Datei wird fr andere freigegeben}
  fm_inherit      =128; {Datei darf nicht "vererbt" werden (?!)}
  fm_default = fm_readwrite;
VAR   {Variablen}
  {Namen der Bilder, von denen ein Aufruf mit GOSUB erfolgte}
  {Eleganter als ein Array wre eine verkettete Pointerliste:}
  PictureStack:Array[1..PictureStackSize] of ^PictureType;
  {Aktuelle Scriptzeile}
  ScriptLineNumber:Integer;
CONST {Vorbelegte Variablen}
  {Aktuelle Unterprogrammebene}
  PictureStackPointer:Integer=0;
  {Name des letzten angezeigten Bildes}
  LastPictureName:PathStr='';

(***********************************************************************
                 String in Grobuchstaben wandeln
***********************************************************************)
FUNCTION UpSTR(S:STRING):STRING;
VAR i:Integer;
BEGIN
  FOR i:=1 TO length(s) DO
  CASE s[i] OF
  'a'..'z': DEC(Byte(s[i]),32);
  '':s[i]:='';
  '':s[i]:='';
  '':s[i]:='';
  {Siehe Funote 4}
  END;
  UpSTR:=S;
END;

(***********************************************************************
               n-tes Wort eines Strings holen
***********************************************************************)
FUNCTION nteswort(s:string;n:integer):string;
VAR spos,wpos:integer;
var wort:string;
BEGIN
  Wort:=''; {Das aktuelle Wort}
  WPos:=0;  {Wortposition}
  SPos:=1;  {Zeichenposition im zu durchsuchenden String}
  WHILE wpos<n DO
  BEGIN
    {Leerzeichen berspringen}
    WHILE (spos<length(s)) and (s[spos]<=' ') do inc(spos);
    inc(wpos);
    wort:='';
    {Buchstaben auswerten}
    while (spos<=length(s)) and (s[spos]>' ') do
    BEGIN
      wort:=wort+s[spos];
      inc(spos);
    END;
  END;
  nteswort:=upstr(wort);
END; {nteswort}

(***********************************************************************
                 Standard-Fehlerbehandlung
***********************************************************************)
Procedure StandardScriptError(errnr,errln:Integer);
{Diese Prozedur wird nie direkt aufgerufen, sondern dient nur
 als Standardbelegung fr die prozedurale Variable "ScriptError"}
BEGIN
  {Falls Grafikmodus, letzten Textmodus wieder einschalten}
  TextMode(LastMode);
  {Falls gerade in einer Textausgabe, neue Zeile}
  WriteLN;
  WriteLN('Script-Fehler in Zeile ',errln,' von ',scriptname,':');
  Case ErrNr of
    seNoScriptFile      : writeln('Scriptdatei nicht gefunden.');
    seLabelNotFound     : writeln('Sprungziel nicht gefunden.');
    seCallStackOverflow : writeln('Zuviele Verschachtelungen.');
    seReturnWithoutGosub: writeln('RETURN ohne GOSUB.');
    seUnknownCommand    : writeln('Unbekannter Befehl');
    else writeln('Der Kaffee ist alle.'); {Siehe Funote 1}
  END;
  HALT(1);
END;

(***********************************************************************
                 Standard-Programmende
***********************************************************************)
{Diese Prozedur wird nie direkt aufgerufen, sondern dient nur
 als Standardbelegung fr die prozedurale Variable "ScriptExit"}
Procedure StandardScriptExit;
BEGIN
  TextMode(LastMode);
  WriteLN;
  WriteLN('Script-Ausfhrung beendet.');
  HALT(0);
END;

(***********************************************************************
                 Script-Befehl interpretieren
***********************************************************************)
{Liest String und gibt Funktionscode ("token number") zurck}
Function ScriptCommand(s:string):ScriptCommandType;
BEGIN
     IF S='GOTO'   then ScriptCommand:=scGOTO
ELSE IF S='GOSUB'  then ScriptCommand:=scGOSUB
ELSE IF S='CALL'   then ScriptCommand:=scGOSUB {Siehe Funote 2}
ELSE IF S='RETURN' then ScriptCommand:=scRETURN
ELSE IF S='EXIT'   then ScriptCommand:=scEXIT
ELSE IF S='BEEP'   then ScriptCommand:=scBEEP {Siehe Funote 3}
ELSE ScriptError(seUnknownCommand,Scriptlinenumber);
END;

(***********************************************************************
                 Erstes Bild eines Scripts holen
***********************************************************************)
Function GetFirstScriptPicture:pathstr;
var s:string;
var t:text;
var pn:pathstr;
begin
  {Standardvorgaben, falls die Funktion erfolglos verlassen wird}
  GetFirstScriptPicture:='';
  ScriptLineNumber:=0;

  {Gibt es die Datei berhaupt?}
  assign(t,Scriptname);
  filemode:=fm_read;
  reset(t);
  filemode:=fm_default;
  if ioresult<>0 then exit;

  {Abschnitt fr das erste Bild suchen:}
  repeat
    readln(t,s);
    inc(ScriptLineNumber);
  until (s[1]=':') or eof(t) or (ioresult<>0);

  {Wenn es einen Abschnitt gibt:}
  if s[1]=':' then
  begin
    LastPictureName:=copy(nteswort(s,1),2,255);
    GetFirstScriptPicture:=LastPictureName;
  end;
  close(t);if ioresult<>0 then;
end; {GetFirstScriptPicture}

(***********************************************************************
             GOSUB-Befehl auswerten: Bild auf Stack sichern
***********************************************************************)
PROCEDURE PushPicture(PN:PATHSTR);
BEGIN
  {Ist noch Platz auf dem Stack?}
  IF PictureStackPointer<PictureStackSize THEN
  BEGIN
    INC(PictureStackPointer);
    NEW(PictureStack[PictureStackPointer]);
    PictureStack[PictureStackPointer]^:=PN
  END
  ELSE {Meckern}
    ScriptError(seCallStackOverflow,Scriptlinenumber);
END;

(***********************************************************************
             RETURN-Befehl auswerten: Bild von Stack holen
***********************************************************************)
PROCEDURE PopPicture(VAR PN:PATHSTR);
BEGIN
  {Stack schon leer?}
  IF PictureStackPointer>0 THEN
  BEGIN
    PN:=PictureStack[PictureStackPointer]^;
    DISPOSE(PictureStack[PictureStackPointer]);
    DEC(PictureStackPointer);
  END
  ELSE {Schimpfen}
    ScriptError(seRETURNwithoutGOSUB,Scriptlinenumber);
END;

(***********************************************************************
                             Label suchen
***********************************************************************)
{LABEL ist das Sprungziel in einer Scriptdatei. Also die Zeile, die mit
 einem Doppelpunkt beginnt und mit GOTO oder GOSUB angesprungen werden
 kann}
FUNCTION LabelVorhanden(Name:string):BOOLEAN;
var t:text;
var gefunden:boolean;
var s:string;
BEGIN
  assign(t,scriptname);
  filemode:=fm_read;
  reset(t);
  filemode:=fm_default;
  gefunden:=false;
  name:=':'+upstr(name);
  repeat
    readln(t,s);
    if s[1]=':'
    then gefunden:=nteswort(s,1)=name;
  until gefunden or eof(t) or (ioresult<>0);
  close(t);
  LabelVorHanden:=Gefunden;
END;


(***********************************************************************
                 Nchstes Bild eines Scripts holen
                  Auswertung der Script-Befehle
***********************************************************************)
Function GetNextScriptPicture(key:string):pathstr;
var s:string;
var t:text;
var PictureName,
    NewPictureName:pathstr;
var gefunden:boolean;
var i:integer;
begin
  {Falls nicht auswertbar, bleibt es beim alten Bild:}
  GetNextScriptPicture:=LastPictureName;

  assign(t,Scriptname);
  scriptlinenumber:=0;
  filemode:=fm_read;
  reset(t);
  filemode:=fm_default;
  if ioresult<>0 then exit;

  {Die zu suchende Zeile:}
  PictureName:=':'+lastpicturename;
  repeat
    readln(t,s);
    inc(scriptlinenumber);
  until ((s[1]=':') and (nteswort(s,1)=PictureName))
      or eof(t) or (ioresult<>0);

  {Wenn es einen Abschnitt fr dieses Bild gibt:}
  gefunden:=false;
  if nteswort(s,1)=PictureName then
  repeat
    readln(t,s);
    inc(scriptlinenumber);
    gefunden:=(nteswort(s,1)=key) or (nteswort(s,1)='ELSE');
  until gefunden or eof(t) or (ioresult<>0) or (s[1]=':');

  {Wenn es eine Aktion fr diesen Tastendruck gibt:}
  if gefunden then
  begin
    NewPictureName:=nteswort(s,3);
    Case ScriptCommand(nteswort(s,2)) of
    scGOTO:
         BEGIN
           If not LabelVorhanden(NewPictureName)
           THEN
              ScriptError(seLabelNotFound,Scriptlinenumber)
           ELSE
           BEGIN
             LastPictureName:=NewPictureName;
             GetNextScriptPicture:=NewPictureName;
           END;
         END;
    scGOSUB:
         BEGIN
           If not LabelVorhanden(NewPictureName)
           THEN
             ScriptError(seLabelNotFound,Scriptlinenumber)
           ELSE
           BEGIN
             PushPicture(LastPictureName);
             LastPictureName:=NewPictureName;
             GetNextScriptPicture:=NewPictureName;
           END;
         END;
    scRETURN:
         BEGIN
           PopPicture(LastPictureName);
           GetNextScriptPicture:=LastPictureName;
         END;
    scBEEP:
         BEGIN
           Sound(1000);
           Delay(100);
           NOSOUND;
         END;
    scEXIT:
         ScriptExit;
    scUNKNOWN:
         ScriptError(seUnknownCommand,Scriptlinenumber);
    END; {CASE}
  end; {gefunden}

  close(t);if ioresult<>0 then;
end; {GetNextScriptPicture}

(***********************************************************************
                       Script-Datei ffnen
***********************************************************************)
Function OpenScript(sn:pathstr):boolean;
var t:text;
begin
  OpenScript:=FALSE;
  ScriptAktiv:=TRUE;
  ScriptName:=fexpand(sn);

  assign(t,sn);
  filemode:=fm_read;
  reset(t);
  filemode:=fm_default;
  if ioresult<>0 then Scriptaktiv:=FALSE;
  close(t); if ioresult<>0 then ScriptAktiv:=FALSE;

  if not scriptaktiv then
  begin
    ScriptError(seNoScriptFile,0);
    exit;
  end;

  OPENSCRIPT:=TRUE;
end; {OpenScript}

(***********************************************************************
                       Script-Datei schlieen
***********************************************************************)
Procedure CloseScript;
begin
  ScriptAktiv:=FALSE;
  ScriptName:='';
end; {CloseScript}
{Siehe Funote 5}

(***********************************************************************
                         Namen der Tasten
***********************************************************************)
Function KeyName(Key1,Key2:Char):String;
{Umwandlung des Tastaturscancodes in einen Tastennamen}
{fehlende Bezeichner bei Bedarf ergnzen...}
BEGIN
CASE Key1 of
  #0: Case Key2 of
      #3:  KeyName:='STRG2';

      #15: KeyName:='SHIFTRIGHT';
      #16: KeyName:='ALTQ';
      #17: KeyName:='ALTW';
      #18: KeyName:='ALTE';
      #19: KeyName:='ALTR';
      #20: KeyName:='ALTT';
      #21: KeyName:='ALTY';
      #22: KeyName:='ALTU';
      #23: KeyName:='ALTI';
      #24: KeyName:='ALTO';
      #25: KeyName:='ALTP';
      #30: KeyName:='ALTA';
      #31: KeyName:='ALTS';
      #32: KeyName:='ALTD';
      #33: KeyName:='ALTF';
      #34: KeyName:='ALTG';
      #35: KeyName:='ALTH';
      #36: KeyName:='ALTJ';
      #37: KeyName:='ALTK';
      #38: KeyName:='ALTL';
      #44: KeyName:='ALTZ';
      #45: KeyName:='ALTX';
      #46: KeyName:='ALTC';
      #47: KeyName:='ALTV';
      #48: KeyName:='ALTB';
      #49: KeyName:='ALTN';
      #50: KeyName:='ALTM';

      #59: KeyName:='F1';
      #60: KeyName:='F2';
      #61: KeyName:='F3';
      #62: KeyName:='F4';
      #63: KeyName:='F5';
      #64: KeyName:='F6';
      #65: KeyName:='F7';
      #66: KeyName:='F8';
      #67: KeyName:='F9';
      #68: KeyName:='F10';

      #71: KeyName:='HOME';
      #72: KeyName:='UP';
      #73: KeyName:='PGUP';

      #75: KeyName:='LEFT';

      #77: KeyName:='RIGHT';

      #79: KeyName:='END';
      #80: KeyName:='DOWN';
      #81: KeyName:='PGDOWN';
      #82: KeyName:='INSERT';
      #83: KeyName:='DELETE';
      #84: KeyName:='SHIFTF1';
      #85: KeyName:='SHIFTF2';
      #86: KeyName:='SHIFTF3';
      #87: KeyName:='SHIFTF4';
      #88: KeyName:='SHIFTF5';
      #89: KeyName:='SHIFTF6';
      #90: KeyName:='SHIFTF7';
      #91: KeyName:='SHIFTF8';
      #92: KeyName:='SHIFTF9';
      #93: KeyName:='SHIFTF10';
      #94: KeyName:='CTRLF1';
      #95: KeyName:='CTRLF2';
      #96: KeyName:='CTRLF3';
      #97: KeyName:='CTRLF4';
      #98: KeyName:='CTRLF5';
      #99: KeyName:='CTRLF6';
      #100: KeyName:='CTRLF7';
      #101: KeyName:='CTRLF8';
      #102: KeyName:='CTRLF9';
      #103: KeyName:='CTRLF10';
      #104: KeyName:='ALTF1';
      #105: KeyName:='ALTF2';
      #106: KeyName:='ALTF3';
      #107: KeyName:='ALTF4';
      #108: KeyName:='ALTF5';
      #109: KeyName:='ALTF6';
      #110: KeyName:='ALTF7';
      #111: KeyName:='ALTF8';
      #112: KeyName:='ALTF9';
      #113: KeyName:='ALTF10';
      #114: KeyName:='CTRLPRTSCR';
      #115: KeyName:='CTRLLEFT';
      #116: KeyName:='CTRLRIGHT';
      #117: KeyName:='CTRLEND';
      #118: KeyName:='CTRLPGDOWN';
      #119: KeyName:='CTRLHOME';
      #120: KeyName:='ALT1';
      #121: KeyName:='ALT2';
      #122: KeyName:='ALT3';
      #123: KeyName:='ALT4';
      #124: KeyName:='ALT5';
      #125: KeyName:='ALT6';
      #126: KeyName:='ALT7';
      #127: KeyName:='ALT8';
      #128: KeyName:='ALT9';
      #129: KeyName:='ALT0';
      #130: KeyName:='ALTSZ';
      #131: KeyName:='ALTAPO';
      #132: KeyName:='CTRLPGUP';
      #133: KeyName:='F11';
      #134: KeyName:='F12';
      #135: KeyName:='SHIFTF11';
      #136: KeyName:='SHIFTF12';
      #137: KeyName:='CTRLF11';
      #138: KeyName:='CTRLF12';
      #139: KeyName:='ALTF11';
      #140: KeyName:='ALTF12';
      #141: KeyName:='CTRLUP';

      #145: KeyName:='CTRLDOWN';

      #150: KeyName:='CTRLGR*';
      ELSE KeyName:='???';
      END;

   #0: KeyName:='NUL';
   #1: KeyName:='SOH';
   #2: KeyName:='STX';
   #3: KeyName:='ETX';
   #4: KeyName:='EOT';
   #5: KeyName:='ENQ';
   #6: KeyName:='ACK';
   #7: KeyName:='BEL';
   #8: KeyName:='BS';
   #9: KeyName:='HT';
  #10: KeyName:='LF';
  #11: KeyName:='VT';
  #12: KeyName:='FF';
  #13: Keyname:='CR';
  #14: Keyname:='SO';
  #15: Keyname:='SI';
  #16: Keyname:='DLE';
  #17: Keyname:='DC1';
  #18: Keyname:='DC2';
  #19: Keyname:='DC3';
  #20: Keyname:='DC4';
  #21: Keyname:='NAK';
  #22: Keyname:='SYN';
  #23: Keyname:='ETB';
  #24: Keyname:='CAN';
  #25: Keyname:='EM';
  #26: Keyname:='SUB';
  #27: Keyname:='ESC';
  #28: KeyName:='FS';
  #29: KeyName:='GS';
  #30: KeyName:='RS';
  #31: KeyName:='US';
  #32..#255: KeyName:=Key1;
  ELSE KeyName:='???';
  END;
END; {KeyName}

(***********************************************************************
                Initialisierungsteil der Script-Unit
***********************************************************************)
begin
  @ScriptError:=@StandardScriptError;
  @ScriptExit:=@StandardScriptExit;
end.

(* ANHANG

Technische Erluterungen
~~~~~~~~~~~~~~~~~~~~~~~~

Filemode

        Turbo Pascal stellt eine globale Variable namens FILEMODE zur
        Verfgung, mit der die Zugriffsrechte auf eine zu ffnende Datei
        festgelegt werden. Magebend ist der Inhalt von FILEMODE beim
        Aufruf der Prozedur RESET. blicherweise enthlt FILEMODE den
        Wert 2 (fm_readwrite), was den normalen Schreib- und Lesezugriff
        erlaubt. Schreibgeschtzte Dateien knnen so nicht geffnet
        werden. Hier mu DOS mitgeteilt werden, da man wirklich
        nur lesen will: FILEMODE:=0 (fm_read).
        Im Netzwerkbetrieb (oder unter WINDOWS) kann es passieren, da
        mehrere Programme gern etwas mit ein und derselben Datei
        unternehmen mchten. Das residente Programm SHARE sorgt
        dann dafr, da auch die Zugriffsrechte fr ANDERE Programme
        verwaltet werden. Standardmig ist ein Kompatibilittsmodus
        gesetzt. Das heit, jede Datei kann (wie unter DOS) immer nur
        von einem Programm offen gehalten werden. Die verschiedenen
        Abstufungen von "fm_deny" verbieten den anderen Programmen
        dann das Lesen und/oder Schreiben der geffneten Datei.
        Wozu das "Inherit"-Bit dient, lt sich aus der Literatur
        nicht zufriedenstellend ableiten [1].


Prozedurale Variablen

        Integer-, Real- und Stringvariablen kennt man ja. Aber was bedeutet
        eine Konstruktion wie

            VAR ScriptError: Procedure(Errnr,Errln:Integer);

        im Deklarationsteil eines Pascal-Programms?

        Wenn Turbo Pascal einen Quelltext kompiliert, ersetzt es alle
        symbolischen Prozedurbezeichner durch die tatschlichen Adressen,
        unter denen diese Routinen bei der Ausfhrung angesprochen werden
        knnen.
        Mit dem Adreoperator "@" lt sich die Speicheradresse der
        jeweiligen Routine ermitteln. Eine prozedurale Variable ist nun das
        Gegenstck dazu: ein Zeiger, dem die Adresse einer beliebigen Routine
        bergeben werden kann:

            @ScriptError:=@StandardScriptError;

        Eine prozedurale Variable kann innerhalb des Programms wie jede
        andere Funktion oder Prozedur aufgerufen werden. Ein hbsches
        Beispiel fr die effektive Anwendung prozeduraler Variablen ist die
        Standardfrage, ob die Ergebnisse einer statischen Berechnung auf dem
        Bildschirm oder auf dem Drucker ausgegeben werden sollen. Wer diese
        Programmteile zweimal schreibt, ist selbst schuld. Es gengt eine
        prozedurale Variable zur Ausgabe einer Zeichenkette. Diese kann man
        nun je nach Bedarf auf eine Prozedur zur Ausgabe eines Strings auf
        Bildschirm und/oder Drucker und/oder Datei und/oder Nulldevice zeigen
        lassen.

        In dieser Unit ist die flexible Ausgabe von Fehlermeldungen vor allem
        deshalb so wichtig, weil das Programm, das die Unit benutzt, zum Teil
        im Grafikmodus luft. Die Script-Unit soll jedoch so unabhngig wie
        mglich von allen Vorgaben des aufrufenden Programms sein.

        Im VEXURY-Programm, das derzeit die Grundlage fr das Bauko-
        Lernprogramm bildet, erscheint die Fehlermeldung zum Beispiel in
        einem hbschen Fenster auf dem Grafikbildschirm.


Script-Datei

        Eine Script-Datei ist im Grunde eine Art Programmquelltext. Ich
        habe den Ausdruck "Script" gewhlt, weil mir "Programmiersprache
        fr audiovisuelle Anwendungen" zu hochgestochen klingt.
        Eine Script-Datei besteht aus Aktionen, die jeweils einem Bild
        zugeordnet werden. Jedes Bild erhlt einen Abschnitt in der
        Script-Datei, der mit der Sprungzielkennung (:) und dem Bildnamen
        beginnt. Danach stehen in einzelnen Zeilen die Tasten, die Aktionen
        auslsen sollen, mit einem Befehl fr die Art der Aktion und dem
        Namen des nchsten Bildes. Die "Tastenbezeichnung" ELSE steht fr
        einen Befehl, der immer dann ausgefhrt wird, wenn keine andere Taste
        pat.

        Beispiel fr eine Script-Datei:

        :EINLEIT.WPG
            A    GOTO  TEIL1.WPG
            B    GOTO  TEIL2.WPG
            C    GOTO  TEIL3.WPG
            ?    GOSUB HILFE.WPG
            X    EXIT
            ELSE GOSUB BADKEY.WPG
        :TEIL1.WPG
            A ...
        :HILFE.WPG
            ELSE RETURN

        Aktionen sind (zur Zeit):

        GOTO    bergabe der Kontrolle an das nchste Bild
        GOSUB   Verzweigung, Rckkehr mit RETURN
        CALL    Identisch mit GOSUB
        RETURN  Rckkehr nach letztem GOSUB
        EXIT    Programmende


Funoten
~~~~~~~~
1)      Diese Fehlermeldung sollte niemals vorkommen, weil die Prozedur zur
        Ausgabe der Fehlermeldung tunlichst mit einer der
        Konstantenbezeichnungen "seXXX" des Interfaceteils aufgerufen werden
        sollte. blicherweise lautet diese Fehlermeldung "Interner Fehler
        0815, bitte setzen Sie sich mit unserer Serviceabteilung in
        Verbindung." Der Sinn ist derselbe: Der Programmierer war
        unaufmerksam; vermutlich, weil der Kaffee alle war.

2)      Die Frage, ob GOSUB oder CALL die einleuchtendere Bezeichnung
        fr einen Unterprogrammaufruf sei, wird hier dem persnlichen
        Geschmack des Scriptautors berlassen. Wer fter Batch- FORTRAN-
        oder Assemblerprogramme schreibt, wird CALL bevorzugen, whrend
        den Augen von BASIC-Programmierer das GOSUB ein vertrauteres
        Bild bietet.

3)      BEEP. Das Tor zur Multimediawelt. Nicht nur die Augen, sogar die
        Ohren knnen nun mit Informationen versorgt werden. Sobald Sourcen
        zur Wiedergabe digitalisierter Aufnahmen vorliegen, knnte
        ja vielleicht noch ein "REPLAY Sounddateiname"-Befehl eingebaut
        werden: "Wenn Sie in einer Stahlhalle, deren Rahmenkonstruktion
        gerade mit dem doppelten der Bemessungslast beansprucht wird,
        DIESES Gerusch hren, so bildet sich gerade genau ber Ihnen
        ein Fliegelenk. Vielen Dank an die Erben von Dipl.-Ing. Medius,
        die uns dieses einmalige Tondokument zur Verfgung stellten."
        Oder so hnlich.

4)      Natrlich hat Turbo Pascal auch eine Funktion, die UPCASE heit.
        Die wandelt aber nur die Buchstaben 'a' bis 'z' in 'A' bis 'Z'
        um (Programsky amerikanskij). Es gibt auch eine DOS-Funktion,
        die Buchstaben korrekt in Grobuchstaben umsetzen kann. Leider
        ist sie so gut wie unbekannt.

5)      Streng betrachtet, ist "schlieen" genauso falsch fr diese Prozedur,
        wie "ffnen" fr "OpenScript" ist. Die Scriptdatei ist eigentlich
        fast immer geschlossen, wenn nicht gerade irgend ein Befehl
        abgearbeitet wird. Da das aufrufende Programm davon jedoch nichts
        wissen mu, und weil "open" und "close" zwei gngige Begriffe fr den
        Beginn und das Ende des Umgangs mit einer Datei sind, kann man sie
        eigentlich guten Gewissens auch weiterhin verwenden.



Quellen
~~~~~~~

[1]     Gnter Born: Das DOS 5 Programmierhandbuch
        Markt & Technik Verlag AG, Mnchen, 1. Auflage 1992
        ISBN 3-87791-316-4
        Signatur FH Bochum: FK 272