{$A+,B-,D+,E-,F+,G-,I-,L+,N-,O+,R-,S-,V-,X+}
(*--------------------------------------------------------------------
  Eine Sammlung hardwarenaher Routinen fr die VGA-Karte.
  Autor: Martin Vogel
         Selbeckerstr. 52
         5800 Hagen 1
  --------------------------------------------------------------------*)

UNIT VGABIOS;

(*--------------------------------------------------------------------
  --------------------------------------------------------------------*)

INTERFACE USES CRT,DOS, GRAPH;
TYPE RGBPalType=Array[0..255,1..3] of Byte;

VAR COLORSCREEN:BOOLEAN;
    CRTCADRESSE:WORD ABSOLUTE 0:$463;
CONST rofak=25; {30}
      grfak=55; {59}
      blfak=20; {11}

Procedure SetBorder(Farbe:Byte);
Function  GetBorder:Byte;
Procedure GetRGBPalette(i:WORD;VAR cr,cg,cb:Byte);
Procedure InRGBPalette(i:byte;VAR r,g,b:Byte);
Procedure OutRGBPalette(i,r,g,b:Byte);
PROCEDURE SetPalette(colornum,color:Byte);
procedure Fade_To_Gray;
procedure Fade_To_Black_255;
procedure Fade_In(var RGBPal:RgbPaltype;von,bis:byte);
procedure Fade_In_16(var RGBPal:RgbPaltype);
Function  Get_VGA_Installed:Boolean;
FUNCTION WasEGArgb(r,g,b:LongInt;Graustufen:Boolean):Byte;
{Sucht in der Standard-EGA-Tabelle nach dem hnlichsten Paletteneintrag}
procedure SETRGBPalBlock(var palrec;ab,anzahl:integer);
Procedure Wait_retrace;
Procedure Wait_vretrace;

(*--------------------------------------------------------------------
  --------------------------------------------------------------------*)

IMPLEMENTATION
VAR R:Registers;

Procedure SetBorder(Farbe:Byte);
BEGIN
  r.ah:=$10; {Set EGA Palette}
  r.al:=1;   {Set Border}
  r.bh:=Farbe;
  intr($10,r);
END;

FUNCTION GetBorder:Byte;
BEGIN
  r.ah:=$10; {Set EGA Palette}
  r.al:=8;   {Get Border}
  intr($10,r);
  GetBorder:=r.bh;
END;

Procedure GetRGBPalette(i:word;VAR cr,cg,cb:Byte);
BEGIN
  r.ah:=$10;
  r.al:=$15;
  r.bx:=i;
  intr($10,r);
  cr:=r.dh;
  cg:=r.ch;
  cb:=r.cl;
END;

Function Get_VGA_Installed:Boolean;
BEGIN
  r.ah:=$1A;
  r.al:=0;
  intr($10,r);
  Get_VGA_Installed:=r.al=$1a;
END;

Procedure Wait_retrace;
BEGIN
  repeat until odd(port[crtcadresse+6]); {Wait_Retrace}
END;

Procedure Wait_vretrace;
BEGIN
  repeat until (port[crtcadresse+6] and 8)<>0; {Wait_VRetrace}
END;

Procedure outRGBpalette(i,r,g,b:Byte);
begin
  port[$3c8]:=i;
  port[$3c9]:=r;
  port[$3c9]:=g;
  port[$3c9]:=b;
end;

Procedure inRGBpalette(i:byte;var r,g,b:Byte);
begin
  port[$3c7]:=i;
  r:=port[$3c9];
  g:=port[$3c9];
  b:=port[$3c9];
end;

procedure fade_to_gray;
var n,i,r,g,b:byte;
begin
  for n:=1 to 42 do
    begin
      for i:=0 to getmaxcolor do
      begin
	inrgbpalette(i,r,g,b);
	if r>42 then dec(r);
	if g>42 then dec(g);
	if b>42 then dec(b);
	if r<42 then inc(r);
	if g<42 then inc(g);
	if b<42 then inc(b);
	outrgbpalette(i,r,g,b);
      end;
    end;
end;

procedure fade_to_black_255;
var i,r,g,b:byte;
var allesdunkel:boolean;
begin
  repeat
    allesdunkel:=true;
    for i:=0 to 255 do
    begin
      inrgbpalette(i,r,g,b);
      if r>0 then dec(r);
      if g>0 then dec(g);
      if b>0 then dec(b);
      if r+g+b>0 then allesdunkel:=false;
      outrgbpalette(i,r,g,b);
    end;
  until allesdunkel;
end;

procedure fade_in(var RGBPal:RGBPalType;von,bis:byte);
var n,i,r,g,b:byte;
var ok:array[0..255] of boolean;
    ok1:boolean;
begin
  for i:=von to bis do ok[i]:=false;
  for n:=1 to 63 do
    begin
      Wait_retrace;
      for i:=von to bis do
      if not ok[i] then
      begin
	inrgbpalette(i,r,g,b);
	ok1:=True;
	if r>(RGBpal[i,1] div 4) then begin dec(r); ok1:=false; end;
	if g>(RGBpal[i,2] div 4) then begin dec(g); ok1:=false; end;
	if b>(RGBpal[i,3] div 4) then begin dec(b); ok1:=false; end;
	if r<(RGBpal[i,1] div 4) then begin inc(r); ok1:=false; end;
	if g<(RGBpal[i,2] div 4) then begin inc(g); ok1:=false; end;
	if b<(RGBpal[i,3] div 4) then begin inc(b); ok1:=false; end;
	outrgbpalette(i,r,g,b);
	ok[i]:=ok1;
      end;
    end;
end;

procedure fade_in_16(var RGBPal:RGBPalType);
var m,n,i,nr,r,g,b:byte;
var ok:array[0..15] of boolean;
    ok1:boolean;
const egapal:array[0..15] of Byte=(0,1,2,3,4,5,20,7,56,57,58,59,60,61,62,63);
begin
  for i:=0 to 15 do ok[i]:=false;
  for n:=1 to 63 do
    begin
      delay(10);
      for m:=0 to 15 do
      if not ok[m] then
      begin
	i:=egapal[m];
	Wait_retrace;
	inrgbpalette(i,r,g,b);
	ok1:=True;
	if r>(RGBpal[m,1] div 4) then begin dec(r); ok1:=false; end;
	if g>(RGBpal[m,2] div 4) then begin dec(g); ok1:=false; end;
	if b>(RGBpal[m,3] div 4) then begin dec(b); ok1:=false; end;
	if r<(RGBpal[m,1] div 4) then begin inc(r); ok1:=false; end;
	if g<(RGBpal[m,2] div 4) then begin inc(g); ok1:=false; end;
	if b<(RGBpal[m,3] div 4) then begin inc(b); ok1:=false; end;
	outrgbpalette(i,r,g,b);
	ok[m]:=ok1;
      end;
    end;
end;

FUNCTION WasEGArgb(r,g,b:LongInt;Graustufen:Boolean):Byte;
{Sucht in der Standard-EGA-Tabelle nach dem hnlichsten Paletteneintrag}
TYPE EGAptyp=Array[0..63,1..3] of byte;
Var f,Fehler	:LongInt;
    i,best	:Byte;
    CONST egap	:egaptyp=
	((0,0,0),(0,0,170),(0,170,0),(0,170,170),
	(170,0,0),(170,0,170),(170,170,0),(170,170,170),
	(0,0,85),(0,0,255),(0,170,85),(0,170,255),
	(170,0,85),(170,0,255),(170,170,85),(170,170,255),
	(0,85,0),(0,85,170),(0,255,0),(0,255,170),
	(170,85,0),(170,85,170),(170,255,0),(170,255,170),
	(0,85,85),(0,85,255),(0,255,85),(0,255,255),
	(170,85,85),(170,85,255),(170,255,85),(170,255,255),
	(85,0,0),(85,0,170),(85,170,0),(85,170,170),
	(255,0,0),(255,0,170),(255,170,0),(255,170,170),
	(85,0,85),(85,0,255),(85,170,85),(85,170,255),
	(255,0,85),(255,0,255),(255,170,85),(255,170,255),
	(85,85,0),(85,85,170),(85,255,0),(85,255,170),
	(255,85,0),(255,85,170),(255,255,0),(255,255,170),
	(85,85,85),(85,85,255),(85,255,85),(85,255,255),
	(255,85,85),(255,85,255),(255,255,85),(255,255,255));
BEGIN
  Fehler:=2147483647; {MaxLongint: kann nur kleiner werden}
  i:=0;
  REPEAT
    If Graustufen
    THEN
      {Helligkeitensumme}
       f:=abs((r*r*rofak+g*g*grfak+b*b*blfak)
	     -(longint(egap[i,1])*egap[i,1]*rofak+
	       longint(egap[i,2])*egap[i,2]*grfak+
	       longint(egap[i,3])*egap[i,3]*blfak))
    ELSE
      {Abstand im dreidimensionalen RGB-Farbraum}
      f:= (r-egap[i,1])*(r-egap[i,1])
	 +(g-egap[i,2])*(g-egap[i,2])
	 +(b-egap[i,3])*(b-egap[i,3]);
    if f<Fehler Then BEGIN Fehler:=f; best:=i; END;
    inc(i);
  UNTIL (i=64) or (Fehler=0);
  WasEGArgb:=best;
END;

procedure SETRGBPalBlock(var palrec;ab,anzahl:integer);
{ Palrec is any string of 16*3 bytes containing the RGB data. }
begin
r.ah:= $10;               { BIOS color register function }
r.al:= $12;               { Subfunction }
r.es:= seg(palrec);       { Address of palette info. }
r.dx:= ofs(palrec);
r.bx:= ab;                 { First register to change }
r.cx:= anzahl;              { Number of registers to change }
intr($10,r);             { Call BIOS }
end;

PROCEDURE SetPalette(colornum,color:Byte);
BEGIN
r.ah:=$10;              {Palette}
r.AL:=0;                {Set single Palette Register}
r.bl:=colornum;
r.bh:=color;
intr($10,r);
END;
(*--------------------------------------------------------------------
  --------------------------------------------------------------------*)

BEGIN
ColorScreen:=MEM[$40:$49]<>7;
END.

