{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-,V-,X+}
Unit VIEWsl;
{Textausgaben in der Statuszeile}

Interface uses graph,dos,crt,VIEWprim,maus;
Type Dateinamentyp=String[12];
const rmSchreiben=1; {Bestimmt den F7-Text bei AusschnittSL}
      rmZoomen=2;
      rmDrucken=3;
VAR
infdatvorh	:BOOLEAN;       {Flag, ob ZEIGWPG.INF vorhanden ist}
infogefunden	:BOOLEAN;	{Ist zur aktuellen Datei Info vorhanden?}
SL_Xpos		:word;		{Cursorposition}
Options		:Pathstr;	{Zeigt die gesetzten Optionen}
CONST
SL_AKTIV        :Boolean=TRUE;  {Bestimmt, ob berhaupt eine Statuszeile
                                 angezeigt wird}

Procedure WriteSL(sltext:string;NeueZeile:Boolean);
Procedure DOSerrSL(nr:integer);
PROCEDURE ZEIGINFOZEILE(name:Dateinamentyp);
Procedure AusschnittSL(Bewegen:Boolean;step:Integer;modus:Integer);
Function Statusline_on:integer;
Function Statusline_off:integer;

Implementation
VAR inf:text;

(*---------------------------------------------------------------------
		  TEXTAUSGABE IN DER STATUSZEILE
---------------------------------------------------------------------*)
Procedure WriteSL(sltext:string;NeueZeile:Boolean);
{Textausgabe in der unteren Statuszeile}
var vp:ViewPortType;
     c:word;
BEGIN
  IF NOT SL_AKTIV THEN EXIT;
getviewsettings(vp);
setviewport(0,maxy+1,getmaxx,getmaxy,false);
setcolor(0);
If NeueZeile Then
BEGIN
  setwritemode(normalput);
  setfillstyle(solidfill,getmaxcolor);
  line(0,1,0,1); {Damit Hargraves SVGA256-Treiber das NormalPut mitkriegt!}
  bar(0,1,getmaxx,getmaxy-maxy);
  SL_Xpos:=3; {Damit bei Karten ohne Border die Zeichen nicht so an den
	       Rand geklatscht sind.}
  setlinestyle(solidln,0,normwidth);
  line(0,0,getmaxx,0);
END;
outstringxy(SL_xpos,2,sltext);
SL_xpos:=getx;
with vp do setviewport(x1,y1,x2,y2,clip);
END; {WRITESL}

(*---------------------------------------------------------------------
		DOS-FEHLERMELDUNG IN DER STATUSZEILE
---------------------------------------------------------------------*)

Procedure DOSerrSL(nr:integer);
BEGIN
  IF NOT SL_AKTIV THEN EXIT;
Case Nr of
    -1: WriteSl('Vorgang storniert.',true);
     0: WriteSL('Fehlerfrei ausgefhrt.',true);
     2: WriteSL('Finde die Datei nicht!',true);
     3: WriteSL('Finde den Suchpfad nicht!',true);
     4: WriteSL('Kann Datei nicht ffnen! Fehlt "FILES=20" in CONFIG.SYS?',true);
     5: WriteSL('DOS verweigert den Zugriff auf die Datei!',true);
    15: WriteSL('Laufwerksbezeichner ungltig.',true);
    17: WriteSL('Umsetzen nur innerhalb eines Laufwerks mglich.',true);
    100: WriteSL('Unerwartetes Dateiende.',true);
    101: WriteSL('Die Diskette ist voll.',true);
    150: WriteSL('Die Diskette ist schreibgeschtzt.',true);
    152: WriteSL('Keine Diskette im Laufwerk!',true);
    154..162: WriteSL('Diskette oder Laufwerk defekt!',true);
    ELSE WriteSL('Fehler beim Dateizugriff (#'+ls(nr)+')',true);
    END;
    if nr<>0 then
    begin
      sound(50);
      delay(200);
      sound(25);
      delay(200);
      nosound;
      delay(800);
    end;
END;

(*---------------------------------------------------------------------
			  INFO-ZEILE ANZEIGEN
---------------------------------------------------------------------*)
PROCEDURE ZEIGINFOZEILE(name:Dateinamentyp);
label ende;
var
    n,z:String;
    einpuf:^puffertyp;
    maxpuf:word;
BEGIN
  IF NOT SL_AKTIV THEN EXIT;
  infogefunden:=FALSE;
  if not infdatvorh then exit;
  maxpuf:=lmin(maxavail,sizeof(puffertyp));
  getmem(einpuf,maxpuf);
  assign(inf,ProgrammPfad+exename+'.INF');
  if maxpuf>128 then settextbuf(inf,einpuf^,maxpuf);
  if ioresult<>0 then; {Es ist zum Kotzen! Wo kommt das her!}
  reset(inf);
  if ioresult<>0 then
  begin
    infdatvorh:=FALSE;
    goto ende;
  end;
  while (ioresult=0) and not eof(inf) and not infogefunden do
  begin
    readln(inf,n);
    readln(inf,z);
    infogefunden:=(n=name);
  end;
  if infogefunden then writesl(z,true);
ENDE:
  close(inf); if ioresult<>0 then infdatvorh:=FALSE;
  FREEMEM(einpuf,MAXPUF);
END;

Procedure AusschnittSL(Bewegen:Boolean;step:Integer;modus:integer);
BEGIN
IF NOT SL_AKTIV THEN EXIT;
if bewegen
then writesl('[Tab] Gre',true)
else writesl('[Tab] Bewegen',true);
if step=1
then writesl('  [Leer] Grob',false)
else writesl('  [Leer] Fein',false);
case modus of
rmSchreiben: writesl('  [F7] Speichern',false);
rmZoomen:    writesl('  [F7] Zoomen',false);
rmDrucken:   writesl('  [F7] Drucken',false);
end;
Writesl('  [ESC] Storno  [F1] Hilfe',false);
END;

(*---------------------------------------------------------------------
                        STATUS DER STATUSZEILE
---------------------------------------------------------------------*)
Function Statusline_on:Integer;
begin
  SL_AKTIV:=TRUE;
  IF fontnr=0
  THEN statusline_on:=getmaxy-TH-4
  ELSE statusline_on:=getmaxy-TH*5 div 4-4;
end;

Function Statusline_off:integer;
begin
  SL_AKTIV:=FALSE;
  Statusline_off:=GetMaxy;
end;

begin end.


