{$A+,B-,D+,E+,F+,I-,L+,N+,O+,R-}
{G und S ber IDE schalten}
{$V-,X+}
{ $DEFINE SEWVIEW} {Keine Bitmaps}

UNIT WPGVIEW;
{Der Teil von VIEW, der fr die WPGs zustndig ist.}
INTERFACE
USES
  DOS,
  CRT,
  GRAPH,
  GENERAL,
  VGABIOS,
  VIEWPRIM,
  VIEWSL,
  DREHFONT;

{$IFOPT N+}
TYPE REAL=DOUBLE;
{$ENDIF}

VAR
    PalPos	:LongInt;	{Dateiposition der Palette in der WPG-Datei}
    PalFirst	:Word;   	{Farbnummer des ersten Paletteneintrags}
    PalFarben	:Word;   	{Anzahl gelesener Paletteneintrge}
    Unbekanntes :Boolean;
    xoff,
    yoff	:LongInt;	{Offset beim Zoomen}

PROCEDURE Setzmonopalette;
PROCEDURE ZEIGWPG(wpgname:pathstr;
		  var virt_x1,virt_y1,virt_x2,virt_y2:Longint;
		  var DarfZoomen:Boolean);

IMPLEMENTATION
TYPE
     lineattyp=record    {Linienattribute}
		 style	:byte;                 {Kennzahl fr Bitmuster}
		 color	:byte;                 {Farbe}
		 width	:word;                 {Strichstrke}
	       END;

     fillattyp=record    {Polygon-, Rechteck-, und Ellipsenfllattribute}
		 pattern:byte;                 {Kennzahl fr Fllmuster}
		 color	:byte;                 {Farbe}
	       END;

     GTextAttrTyp=record {Grafik Text 1}
	    nccw	:word;               {Nominal character cell width}
	    cch		:word;               {Character cell height}
	    r5w		:array[1..5]of word; {Reserved}
	    fdf		:word;               {Font descriptor flag}
	    r1b		:byte;               {Reserved}
	    ha		:byte;               {Horizontal adjust}
	    va		:byte;               {Vertical adjust}
	    tc		:byte;               {Text color}
	    rw		:word;               {Rotationswinkel}
	    END;
VAR
    lineatt	:lineattyp;   	{Die aktuellen Linienattribute}
    fillatt	:fillattyp;   	{Die aktuellen Fllattribute}
    wpgversion	:byte;     	{WP 5.0 und 5.1 ist Version 1}
				{Im Dateiheader steht die Versionsnummer
				 brigens nochmal.}
    postscript	:Boolean;  	{Unklar, siehe developer's toolkit}
    GTA		:GTextAttrTyp;  {Fr Texte in der WPG-Datei}
    recnr	:Byte;          {Datensatztyp}
    reclen	:longint;      	{Datensatzlnge ohne Datensatzheader}
VAR WPG		:File;

TYPE
     Zeilentyp=array[-3..Maxint] of Byte; {Enthlt eine gelesene Bitmap-Zeile}
     Zeilenzeigertyp=^Zeilentyp;
     PPType=Procedure(x,y:Integer;b:word);
	    {Damit nicht bei der Bitmapdarstellung fr jedes Pixel
	     eine Fallunterscheidung gemacht werden mu, gibt es eine
	     Vielzahl von Putpixelvarianten fr jeden Modus.}
     Tripeltype=Record r,g,b:Integer end; {Fr Farbdithering}
     Tripelzeilentyp=ARRAY[-1..1024] of Tripeltype;
     MonoDithlinetyp=ARRAY[-1..1024] of integer;
VAR
    Diesezeile,
    Unterzeile  :^Tripelzeilentyp;
		 {Fr Farbdithering 256 auf 16}
    fehler1     :^MonoDithlinetyp;
    fehler2     :^MonoDithlinetyp;
		 {Fr Monochromdithering.}
    x_alt:Integer; {x-Koordinate des letzten gesetzten Bildpunktes}
    y_alt:Integer; {y-Koordinate der letzten dargestellten Bildzeile}
    Zeile:Zeilenzeigertyp; {Hlt eine gelesene Bitmapzeile}
    bmxoff,			{Fr Dithering}
    bmxvaria,
    bmyvaria	:LongInt;       {Speziell fr BitMaps}
    bmxppz,
    bmyppz	:Word;		{Auflsung Punkte pro Zoll}
    bmbreite,
    bmhoehe	:word;		{Hhe,Breite des BitMap in Pixeln}
var img:record			{Fr PutImage}
	    breite,
	    hoehe:word;
	    zeile:Bytefeldtyp;
	  end;


Function MIN(a,b:WORD):WORD;
BEGIN
  IF a<b then min:=a else min:=b;
END;

(*---------------------------------------------------------------------
       WP-FLLMUSTER
---------------------------------------------------------------------*)

Procedure SetWPFillStyle(Pattern,Color:Integer);
const wpmuster:array[0..63] of FillPatternType=
     (
{ 0} (  0,  0,  0,  0,  0,  0,  0,  0),
{ 1} (255,255,255,255,255,255,255,255),
{ 2} (204,153, 51,102,204,153, 51,102),
{ 3} (136, 17, 34, 68,136, 17, 34, 68),
{ 4} (128,  1,  2,  4,  8, 16, 32, 64),
{ 5} (221,221,119,119,221,221,119,119),
{ 6} (136, 85, 34, 85,136, 85, 34, 85),
{ 7} (128, 65, 34, 20,  8, 20, 34, 65),
{ 8} ( 51, 51, 51, 51, 51, 51, 51, 51),
{ 9} ( 17, 17, 17, 17, 17, 17, 17, 17),
{10} (  1,  1,  1,  1,  1,  1,  1,  1),
{11} (128,  0,  0,  0,  8,  0,  0,  0),
{12} (136,  0, 34,  0,136,  0, 34,  0),
{13} (136, 34,136, 34,136, 34,136, 34),
{14} (170, 85,170, 85,170, 85,170, 85),
{15} (119,221,119,221,119,221,119,221),
{16} (119,255,221,255,119,255,221,255),
{17} (127,255,255,255,247,255,255,255),
{18} (255,255,  0,  0,255,255,  0,  0),
{19} (255,  0,  0,  0,255,  0,  0,  0),
{20} (255,  0,  0,  0,  0,  0,  0,  0),
{21} (255,255,204,204,255,255,204,204),
{22} (255,136,136,136,255,136,136,136),
{23} (255,128,128,128,128,128,128,128),
{24} ( 51,153,204,102, 51,153,204,102),
{25} ( 17,136, 68, 34, 17,136, 68, 34),
{26} (  1,128, 64, 32, 16,  8,  4,  2),
{27} ( 65, 34, 20,  8,  1,  2,  4,  8),
{28} (124,184, 17,139,199,163, 17, 58),
{29} (102,153,153,102,102,153,153,102),
{30} ( 24, 36, 66,129, 24, 36, 66,129),
{31} (131,  7, 14, 28, 56,112,224,193),
{32} (240,240,240,240, 15, 15, 15, 15),
{33} (  1,  2,  4,  8, 24, 36, 66,129),
{34} (129,  3,  6, 12, 28, 54, 99,193),
{35} (131,  7, 14, 28, 60,126,231,195),
{36} (129, 66, 36, 24,  8,  4,  2,  1),
{37} (129,195,102, 60, 24, 12,  6,  3),
{38} (131,195,231,126, 60, 28, 14,  7),
{39} (255,128,128,128,255,  8,  8,  8),
{40} (255,192,192,192,255, 24, 24, 24),
{41} (136,136,136,143,136,136,136,248),
{42} (204,204,204,207,204,204,204,252),
{43} (  0,129,195,231,231,219,189,126),
{44} ( 31, 62,124,248,124, 62, 30, 15),
{45} ( 12, 24, 48, 96, 48, 24, 12,  6),
{46} (240,150,150,240, 15,105,105, 15),
{47} (240,160, 80, 40, 20, 10,  5, 15),
{48} (129, 66, 60, 60, 60, 60, 66,129),
{49} ( 31, 31,240,240, 16, 31,  0,  0),
{50} ( 28, 28,128,128, 28, 28, 28, 28),
{51} (126,254,254,254,254,252,248,156),
{52} ( 48,104,192,200, 96, 56, 30, 15),
{53} (  8, 16, 32, 65,130, 68, 40, 16),
{54} ( 15, 31, 63,127,254,124, 56, 16),
{55} (255,  0, 24,231, 24, 60,  0,  0),
{56} (199,199, 32,  8, 16,  8,199,199),
{57} (231,231,231,  0,  0,225,225,231),
{58} (249,242,228,200,144, 32, 64,128),
{59} (248,140,134,130,243,129,129,255),
{60} (195,231,189,153,129,129,129,129),
{61} (153,195,102, 60,153, 90, 36,  0),
{62} (255,127, 63, 31, 15,  7,  3,  1),
{63} (128,192,224,240,248,252,254,255));

BEGIN
  If Pattern in [0..63]
  then SetFillPattern(wpmuster[Pattern],Color)
  else SetFillStyle(SolidFill,Color);
END;

(*---------------------------------------------------------------------
      TRICK: FLLMUSTER BEI SCHWARZER FLLFARBE INVERTIEREN
---------------------------------------------------------------------*)

Procedure SetFillStyleNoBlack(Pattern,Color:Integer);
var fill:FillPatternType;
var i:integer;
BEGIN
  SetwpFillStyle(Pattern,color);
  if (color=0) and (pattern in [2..254]) then
  begin
    GetFillPattern(fill);
    for i:=1 to 8 do fill[i]:=not fill[i];
    SetFillPattern(fill,hgfarbe);
  end
END;

(*---------------------------------------------------------------------
       SETZEN DER RGB-PALETTE FR MONOCHROMDARSTELLUNG AUF FARBE
---------------------------------------------------------------------*)

PROCEDURE Setzmonopalette;
  BEGIN
    IF NOT egagefunden THEN
    BEGIN
      setpalette(0,0);
      setpalette(15,15);
    END;

    IF vgakarte THEN
    BEGIN
      outrgbpalette(0,0,0,0);
      outrgbpalette(getmaxcolor,63,63,63);
    END
    else {also keine VGA-Karte}
    IF egagefunden THEN
    BEGIN
      setpalette(0,0);
      setpalette(15,63)
    END
    else {also keine EGA-Karte}
    BEGIN
      graph.setrgbpalette(0,0,0,0);
      graph.setrgbpalette(getmaxcolor,63,63,63);
    END
  END; {SetzmonoPalette}


(*---------------------------------------------------------------------
		ANZEIGE EINES BITMAPS
---------------------------------------------------------------------*)


(*---------------------------------------------------------------------
     PROZEDUREN ZUM SETZEN EINES BILDPUNKTES IN VERSCHIEDENEN MODI
---------------------------------------------------------------------*)
  PROCEDURE CBAR(x1,y1,x2,y2,Farbe:Integer);
  CONST FA:Integer=0;
  CONST x1a:Integer=0;
  {Farbe 1001: Initialisieren}
  {Farbe 1002: Puffer leeren}

  BEGIN
    if (farbe=fa)
    then exit
    else
    if (x1a<pred(x1)) and (Farbe<>1001)
    then
    begin
      if hi(fa)<>0 {1001 oder 1002}
      then fa:=farbe;
      SetFillStyle(SolidFill,fa);
      bar(x1a,y1,pred(x1),y2);
    end;
    x1a:=x2;
    fa:=farbe;
    if farbe>255 then exit;

    if (x1=x2) and (y1=y2)
    THEN Graph.PutPixel(x1,y1,Farbe)
    ELSE
      BEGIN
	SetFillStyle(SolidFill,farbe);
	bar(x1,y1,x2,y2);
      END;
  END;


(*--------------------------------------------------------------------
   Neu in Version 4.1: Farbdithering fr 256-auf-16-Farbdarstellung
---------------------------------------------------------------------*)
  PROCEDURE InitEGA256;
  var i:byte;
  BEGIN
    EGAPALgeaendert:=TRUE;
    If VGAKarte then
    BEGIN
     FOR i:=0 to 15 do setpalette(i,i);
     For i:=0 to 7 do
      OUTRGBpalette(i,
		   (i and 4)shr 2*127, {Rot}
		   (i and 2)shr 1*127, {Grn}
		   (i and 1)*127);     {Blau}

     For i:=0 to 7 do
      OUTRGBpalette(8+i,
		   (i and 4)shr 2*255, {Rot}
		   (i and 2)shr 1*255, {Grn}
		   (i and 1)*255);     {Blau}
    END
    ELSE
    BEGIN
    SetPalette(0,0);  {Schwarz}
    For i:=1 to 8 do
      Setpalette(i,7);
    For i:=1 to 7 do
      Setpalette(8+i,9*(i and 1)+18*((i and 2)shr 1)+36*((i and 4)shr 2));
    END;
  END;

  PROCEDURE InitGrau16;
  var i:byte;
      zvF:Boolean;
  BEGIN
    zvf:=ZuvieleFarben;
    ZuVieleFarben:=False;
    FOR i:=0 to 15 do
      SETRGBPalette(i,17*i,17*i,17*i);
    ZuVieleFarben:=zvF;
  END;

{$F+}
  {Auf diese Prozeduren wird ber Pointer zugegriffen}
  PROCEDURE HercPutMono(x,y:Integer;Color:Word);
  {Setzt nur schwarze Pixel}
  {ACHTUNG! Clipping mu auerhalb stattdfinden!}
  VAR ScrOfs	: Word;
  const Bitmask	: array[0..7] of Byte=(128,64,32,16,8,4,2,1);
  BEGIN
    ScrOfs := HGAddress[y] + x SHR 3;
    Mem[$B000:ScrOfs] := Mem[$B000:ScrOfs] AND NOT Bitmask[x and 7]
  END;


  PROCEDURE HercputFarbe(x,y:Integer;Farbe:Word);
  {Der Dither-Algorithmus unterscheidet vom ursprnglichen
   Floyd-Steinberg-Dithering insofern, da ein kreuzweiser
   Fehlerausgleich stattfindet, zu je einem Viertel nach rechts,
   unten links, unten und unten rechts. Falls vor mir noch
   niemand diese Idee gehabt haben sollte, nenne ich diesen
   Algorithmus "Kreuzausgleich nach Vogel".}
  VAR f,f4	:integer;
  BEGIN
     dec(x,bmxoff);
     if x=x_alt then exit;
     x_alt:=x;

     f:=Graupalette[farbe]+fehler1^[x];
     if f>127 then dec(f,255) else hercputmono(x+bmxoff,y,0);
     {Hell ist der Hintergrund schon}
     f4:=f div 4;
     inc(fehler1^[x+1],f4);
     fehler2^[x+1]:=f4;
     inc(fehler2^[x],f4);
     inc(fehler2^[x-1],f4);
  END;

  PROCEDURE EGAput256(x,y:Integer;Farbe:Word);
  {Farb Dithering}
  VAR farbfehler	:Tripeltype;
      z:byte;
  BEGIN
     dec(x,bmxoff);
     if x=x_alt then exit;
     x_alt:=x;

     With Diesezeile^[x] do
     begin
       Inc(r,RGBpalette[farbe,1]);
       Inc(g,RGBpalette[farbe,2]);
       Inc(b,RGBpalette[farbe,3]);
       {Farbfehler wird auf 4 Punkte verteilt:}
       Farbfehler.r:=lo(r)shr 2;
       Farbfehler.g:=lo(g)shr 2;
       Farbfehler.b:=lo(b)shr 2;
       if hi(b or g or r)=0
       then
	 graph.putpixel(x+bmxoff,y,0)
       else
	 graph.putpixel(x+bmxoff,y,hi(b)+hi(g)shl 1+hi(r)shl 2+8);
     end;

     inc(Diesezeile^[x+1].r,FarbFehler.r);
     inc(Diesezeile^[x+1].g,FarbFehler.g);
     inc(Diesezeile^[x+1].b,FarbFehler.b);
     inc(unterzeile^[x].r,FarbFehler.r);
     inc(unterzeile^[x].g,FarbFehler.g);
     inc(unterzeile^[x].b,FarbFehler.b);
     inc(unterzeile^[x-1].r,FarbFehler.r);
     inc(unterzeile^[x-1].g,FarbFehler.g);
     inc(unterzeile^[x-1].b,FarbFehler.b);
     unterzeile^[x+1].r:=FarbFehler.r;
     unterzeile^[x+1].g:=FarbFehler.g;
     unterzeile^[x+1].b:=FarbFehler.b;
  END; {EGAput256}

  PROCEDURE MonoputFarbe(x,y:Integer;Farbe:Word);
  {Der selbe Algorithmus wie eben}
  VAR f,f4	:integer;
  BEGIN
     dec(x,bmxoff);
     if x<0 then exit;
     if x=x_alt then exit; {Kann denselben Punkt nicht zweimal setzen.}
     x_alt:=x;

     f:=Graupalette[farbe]+fehler1^[x];
     if f>127 then dec(f,255) else graph.putpixel(x+bmxoff,y,0);
     {Wei ist der Hintergrund schon}

     {Die ursprnglichen Befehle stehen im Anhang...}
     {Hier eine krzere Variante:}
     f4:=f div 4;
     inc(fehler1^[x+1],f4);
     fehler2^[x+1]:=f4;
     inc(fehler2^[x],f4);
     inc(fehler2^[x-1],f4);
  END;

  PROCEDURE MonoputFarbe_OD(x,y:Integer;Farbe:Word);
  {Ordered Dithering}
  BEGIN
     if Graupalette[farbe]<=DiMat^[x and 7,y and 7]
     then graph.putpixel(x,y,0);
  END;

  PROCEDURE MonoZoomFarbe(x,y:Integer;Farbe:word);
  BEGIN
     SetFillPattern(MonoPattern[GrauPalette[farbe]div 4{17}],getmaxcolor);
     SetFillStyle(UserFill,getmaxcolor);
     bar(succ(x_alt),succ(y_alt),x,y);
     x_alt:=x;
  END;

  PROCEDURE ZoomPutPixel(x,y:Integer;Farbe:Word);
  BEGIN
     Cbar(succ(x_alt),succ(y_alt),x,y,Farbe);
     x_alt:=x;
  END;

  PROCEDURE ZoomPutPixel256auf16(x,y:Integer;Farbe:Word);
  BEGIN
     if x>x_alt then
     Cbar(succ(x_alt),succ(y_alt),x,y,farbe div 16);
     x_alt:=x;
  END;


  PROCEDURE PutPixel256auf16(x,y:Integer;Farbe:Word);
  BEGIN
     Graph.PutPixel(x,y,farbe div 16);
  END;


  PROCEDURE EGAput256_OD(x,y:Integer;Farbe:Word);
  {Ordered Dithering 256 Farben mit 8}
  VAR C,d:Byte;
  BEGIN
    C:=0;
    d:=diMat^[x and 7,y and 7];
    if RGBpalette[farbe,1]>d Then inc(c,4);
    if RGBpalette[farbe,2]>d Then inc(c,2);
    if RGBpalette[farbe,3]>d Then inc(c,1);
    if c<>0 then inc(c,8); {Schwarz oder helle Farben}
    graph.putpixel(x,y,c);
  END;

  PROCEDURE EGAZoom256(x,y:Integer;Farbe:Byte);
  VAR i,j:Integer;
  BEGIN
     for i:=x_alt+1 to x do
       for j:=y_alt+1 to y do
	 EGAput256_OD(i,j,Farbe);
     x_alt:=x;
  END;
{$IFOPT O-}
{$F-} {Wenn als Overlay, dann F+ aktiviert lassen!}
{$ENDIF}

(*---------------------------------------------------------------------
		    Monochrome Zeile nach 256
---------------------------------------------------------------------*)
Procedure BitzuByte(VAR Z:ByteFeldTYP;MonoBytes:integer);
VAR Lauf:Integer;
    c,i:Byte;
    BytePos:integer;
BEGIN
  BytePos:=8*MonoBytes-1;
  For Lauf:=MonoBytes-1 Downto 0 do
  BEGIN
    c:=Z[Lauf];
    for i:=7 downto 0 do
    begin
      if odd(c) then z[BytePos]:=255 else z[Bytepos]:=0;
      c:=c shr 1;
      dec(BytePos);
    end;
  END;
END;

(*---------------------------------------------------------------------
	  4 Monochrome Zeilen nach 16 Graustufen
---------------------------------------------------------------------*)

Procedure Monomachgrau(y:Integer;Zeile:Bytefeldtyp;Laenge:Integer);
VAR M,Y4:Integer;
    C:Byte;
    W:Word;
    m2gzeile    :ARRAY[0..3] of BytefeldTyp;
		 {Fr Mononachgrau}
BEGIN
  move(zeile[0],m2gzeile[y mod 4][0],Laenge);
  if y mod 4 = 3 then
  BEGIN
    Y4:=Y DIV 4;
    for m:=0 to laenge-1 do
    begin
      W:=LRBitSum(M2GZeile[0,m],M2GZeile[1,m],M2GZeile[2,m],M2GZeile[3,m]);
      putpixel(M*2,y4,hi(W));
      putpixel(M*2+1,y4,lo(W));
    end;
  END;
END;


(*---------------------------------------------------------------------
		  DARSTELLUNG EINES WPG-BITMAPS
---------------------------------------------------------------------*)

PROCEDURE BITMAP(xoff1,yoff1,x1,y1,x2,y2:integer;BytesPacked:LongInt;bitmap2:boolean);
VAR
cbpp		:word;      {Farbbits pro Pixel
		(1=mono, 2=4 Farben, 4=16 Farben, 8=256 Farben)}
Lauf,b1,b2	:Byte;
i,n,xLauf,yLauf	:integer;
ZeileWiederholt	:Boolean;
putpixel	:pptype;
WPGPos		:Longint;
MaxWPGPosErwartet
		:Word;
Byteszuviel     :Longint;     {COLORIX schreibt die falsche Lnge}
EndFuell	:Byte;
ZeilenPufferLaenge,
Laenge		:WORD;
VAR Maxpuffer:WORD;
VAR Puffer:^Puffertyp;

  FUNCTION ReadWPGByte:Byte;
  VAR gelesen:Word;
  {Ende ist global und zeigt das Ende einer Zeichnung an}
  BEGIN
    If WPGPos>MaxPuffer
    THEN
    BEGIN
      If BytesPacked>MaxPuffer
      THEN
        BEGIN
	  BlockRead(WPG,Puffer^,MaxPuffer,gelesen);
	  ENDE:=(Gelesen<MaxPuffer) or (ioresult<>0);
	  DEC(BytesPacked,MaxPuffer)
        END
      ELSE
        BEGIN
	  BlockRead(WPG,Puffer^,BytesPacked,gelesen);
	  ENDE:=(gelesen<BytesPacked) or (ioresult<>0);
          MaxWPGPosErwartet:=BytesPacked;
          BytesPacked:=0;
        END;
      WPGPos:=1;
    END;

    {Eine auerordentlich hliche Stelle :-(
     Nachdem ich bereits beim Palettenrecord fr ein Fremdprogramm
     einen Fehler ausgebgelt habe (Graphics Workshop in der Version
     2.7 schreibt die falsche Palettengre), hier etwas fr
     COLORIX-Anwender, die ihr Kunstwerk unbedingt im WPG-Format
     sichern muten, denn COLORIX 1.1 hat Probleme mit der Lnge eines
     Bitmaps. Hier sind manchmal noch ein paar Bytes brig :-)  }

    If WPGPos>MaxWPGPosErwartet
    Then
      begin
	BlockRead(WPG,Puffer^[WPGPos],1);
	if ioresult<>0 then ende:=true;
	inc(BytesZuviel);
      end; {colorix}

    ReadWPGByte:=Puffer^[wpgpos];
    inc(wpgpos);
  END;


  PROCEDURE ZEIGZEILE(Zeile:ZeilenZeigertyp;Laenge:INTEGER;Wiederholen:Boolean);
  VAR x,x0,xhilf,y	:Integer;
      b,b1,b2   :Byte;
      Zeile256  :Zeilenzeigertyp;
      AllePunkteSetzen:Boolean;
      const Breite:Integer=1;
      var gmc:array[0..1] of Byte; {gmc[1] ist getmaxcolor, damit gezoomte
				    Bitmaps nicht blau sind.}

  BEGIN
  iF ZOOMBITMAP or BitMap2
  THEN y:=yoff-hiword(yvaria*y2-(yLauf-1)*bmyvaria)
  ELSE y:=hiword((yLauf-1)*bmyvaria);
  INC(YLauf);
  {Keine doppelten Zeilen:}
  if (y=y_alt) or (y<0) or (y>maxy)
  then begin y_alt:=y; exit end;
  if keypressed
  then BEGIN Ende:=TRUE;exit; END;
  If (ZoomBitmap and not einszueins) or Bitmap2
  then x_alt:=lmax(-1,xoff+hiword(x1*xvaria)-1)
  else x_alt:=-1;

  {Wenn CBAR verwendet wurde, Puffer initialisieren:}
   if (@putpixel=@zoomputpixel)
   or (@putpixel=@zoomputpixel256auf16)
   then putpixel(x_alt,y,1001)
   else
   if (@putpixel=@monoputfarbe)
   or (@putpixel=@hercputfarbe)
   then
     begin
       fehler1^:=fehler2^;
       fehler2^[0]:=0;
     end
   else
   if (@putpixel=@egaput256)
   then
     begin
       diesezeile^:=unterzeile^;
       unterzeile^[0].r:=0;
       unterzeile^[0].g:=0;
       unterzeile^[0].b:=0;
     end;
  {Geringe Rundungsfehler (0.33%) werden geschluckt:}
  AllePunktesetzen:=(BMXVaria>Eins-200) and (BMXVaria<Eins+200);
  Case cbpp of
  1: BEGIN {Monochrom}
       IF AllePunktesetzen {Wenn alle Punkte nebeneinander gesetzt werden}
       and (HERCULES or EGAVGA16 or (Getmaxcolor=255))
       and not bitmap2
       and not zoombitmap
       {und direkt in den Speicher geschrieben werden kann}
	 THEN
	 IF hercules
	 {Das Bild ist ja schon bitrichtig fr die Hercules-
	  Karte vorhanden. Ab in den Bildspeicher:}
	 THEN move(Zeile^[1],
		   mem[$b000:hgaddress[y]],
		   min(maxx,(bmbreite+7)) div 8)
	 ELSE if EGAVGA16
	 THEN
	 {Dann ab in die erste BitPlane, das geht ja toll!}
	      move(Zeile^[1],
		   mem[$a000:y*EGAVGABreite],
		   min(maxx,(bmbreite+7)) div 8)
	 ELSE {256 Farben}
	 begin
	   if not Wiederholen then
	   begin
	   Breite:=min(maxx-1,8*Laenge-1);
	   Laenge:=min(Laenge,(Breite+7)div 8);
	   move(Zeile^[1],img.zeile,Laenge);
	   bitzubyte(img.Zeile,Laenge);
	   while (img.zeile[Breite]<>0) and (Breite>1) do dec(Breite);
	   end;
	   img.breite:=Breite;
	   img.hoehe:=0;
	   putimage(xoff+Hiword(xvaria*x1),y,img,copyput);
	 end
       ELSE {also nicht direkt in den Speicher schreiben:}
	 if ZoomDiesBitMap
	 Then
	 BEGIN
	 gmc[0]:=0;gmc[1]:=getmaxcolor;
	 For x:=0 to Laenge-1 do
	 BEGIN
	   b:=zeile^[x+1];
	   x0:=(HiWord(XVaria*X1)+XOff)*eins div bmxvaria+x*8;
	   if (x0>=0) and (x_alt<=maxx) then
	   begin
	   putpixel(hiword(x0*bmxvaria),y,gmc[b shr 7]); b:=b shl 1; inc(x0);
	   putpixel(hiword(x0*bmxvaria),y,gmc[b shr 7]); b:=b shl 1; inc(x0);
	   putpixel(hiword(x0*bmxvaria),y,gmc[b shr 7]); b:=b shl 1; inc(x0);
	   putpixel(hiword(x0*bmxvaria),y,gmc[b shr 7]); b:=b shl 1; inc(x0);

	   putpixel(hiword(x0*bmxvaria),y,gmc[b shr 7]); b:=b shl 1; inc(x0);
	   putpixel(hiword(x0*bmxvaria),y,gmc[b shr 7]); b:=b shl 1; inc(x0);
	   putpixel(hiword(x0*bmxvaria),y,gmc[b shr 7]); b:=b shl 1; inc(x0);
	   putpixel(hiword(x0*bmxvaria),y,gmc[b shr 7]);
	   end else x_alt:=hiword(x0*bmxvaria);
	 END
	 END {ZoomDiesBitmap}
	 ELSE
	 For x:=0 to Laenge-1 do
	 BEGIN
	   b:=not Zeile^[x+1]; {gesetzt werden die schwarzen Punkte}
	   if b<>0 then
	   begin
	   x0:=(HiWord(XVaria*X1)+XOff)*eins div bmxvaria+x*8+7;
	   if (x0>=0) and (x_alt<=maxx) then
	   begin
	   {Schnelligkeit ist alles:}
	   if odd(b) then putpixel(hiword(x0*bmxvaria),y,0); b:=b shr 1; dec(x0);
	   if odd(b) then putpixel(hiword(x0*bmxvaria),y,0); b:=b shr 1; dec(x0);
	   if odd(b) then putpixel(hiword(x0*bmxvaria),y,0); b:=b shr 1; dec(x0);
	   if odd(b) then putpixel(hiword(x0*bmxvaria),y,0); b:=b shr 1; dec(x0);

	   if odd(b) then putpixel(hiword(x0*bmxvaria),y,0); b:=b shr 1; dec(x0);
	   if odd(b) then putpixel(hiword(x0*bmxvaria),y,0); b:=b shr 1; dec(x0);
	   if odd(b) then putpixel(hiword(x0*bmxvaria),y,0); b:=b shr 1; dec(x0);
	   if odd(b) then putpixel(hiword(x0*bmxvaria),y,0);
	   end else x_alt:=hiword(x0*bmxvaria);
	   end;
	 END;
     END; {Monochrom}
  2: BEGIN {4 Farben}
       For x:=0 to Laenge-1 do
       BEGIN
	 x0:=(HiWord(XVaria*X1)+XOff)*eins div bmxvaria+x*4;
	 if (x0>=0) and (x_alt<=maxx) then
	 begin
	 b:=Zeile^[x+1];
	 putpixel(hiword(x0*bmxvaria),y,b shr 6);
	 putpixel(hiword((x0+1)*bmxvaria),y,(b shr 4) and 3);
	 putpixel(hiword((x0+2)*bmxvaria),y,(b shr 2) and 3);
	 putpixel(hiword((x0+3)*bmxvaria),y,b and 3);
	 end else x_alt:=hiword(x0*bmxvaria);
       END;
     END; {4 Farben}
  4: BEGIN {16 Farben}
       if     AllePunktesetzen
	  and (maxavail>2*Laenge+5)
	  and (getmaxcolor=255)
	  and not monochrom
       THEN
	 begin
	   {4 Bytes Header fr PutImage:}
	   GetMem(Zeile256,2*Laenge+5);
	   {Hier werden die beiden Nibble aufgepfriemelt und dann
	    geht's mit PutImage direkt in den Bildspeicher}
	   FOR x:=1 to Laenge do
	   BEGIN
	     b1:=Zeile^[x];
	     x0:=x shl 1;
	     Zeile256^[x0-1]:=b1 shr 4;
	     Zeile256^[x0]  :=b1 and 15;
	   END;
	   Zeile256^[-3]:=lo(Laenge*2-1);  {X-Differenz}
	   Zeile256^[-2]:=hi(Laenge*2-1);  {High Byte}
	   Zeile256^[-1]:=0;               {Y-Differenz}
	   Zeile256^[ 0]:=0;               {Bei einer Zeile: null}
	   Putimage(2*(HiWord(XVaria*X1)+XOff)div 2,y,Zeile256^[-3],copyput);
	   FREEMEM(Zeile256,2*Laenge+5);
	 end {1:1 im 256-Farb-Modus}
       ELSE
       {Tja, jetzt wird's wirklich langsam...}
       BEGIN
       xhilf:=XOff+hiword(XVaria*X1);
       For x:=1 to Laenge do
       BEGIN {Jeden Punkt einzeln setzen:}
	 x0:=XHilf+hiword(bmxvaria*(x shl 1-1));
	 if (x0>=0) and (x_alt<=maxx) then
	 begin
	 b1:=Zeile^[x];
	 putpixel(x0-hiword(bmxvaria),y,b1 shr 4);
	 putpixel(x0,y,b1 and 15);
	 end else x_alt:=x0;
       END;
       END;
     END; {16 Farben}
  8: BEGIN {256 Farben}
       if     AllePunktesetzen
	  and not zuvielefarben  {und 256 Farben dargestellt werden knnen...}
	  and not monochrom      {und das auch erwnscht ist...              }
       then                      {dann wird dieses Programm einmal richtig   }
	 begin                   {schnell:                                   }
	   Laenge:=lmin(Laenge-1,maxx); {Clipping wegen Dateiliste}
				    {4 Byte Header fr PutImage:  }
	   Zeile^[-3]:=lo(Laenge);  {X-Differenz                  }
	   Zeile^[-2]:=hi(Laenge);  {High Byte davon              }
	   Zeile^[-1]:=0;           {Y-Differenz ist bei nur einer}
	   Zeile^[ 0]:=0;           {Zeile immer null             }
	   Putimage(xoff,y,Zeile^[-3],copyput); {Und zupp!}
	 end
       else
         begin
         x_alt:=HiWord(XVaria*X1)+XOff;
	 For x:=0 to Laenge-1 do
	 begin
	   x0:=HiWord(XVaria*X1)+XOff+hiword(x*bmxvaria);
	   if (x0>=0) and (x_alt<=maxx)  {Clipping}
           then putpixel(x0,y,Zeile^[x+1])
           else x_alt:=x0;
	   {Ghn! Und bis zur Version 5.17 war das IMMER so langsam!}
	 end;
         end;
     END; {256 Farben}
   END;{CASE ColorBitsPerPixel}
   {Wenn CBAR verwendet wurde, Puffer leeren:}
   if (@putpixel=@zoomputpixel)
   or (@putpixel=@zoomputpixel256auf16)
   then putpixel(0,y,1002);
   y_alt:=y;
  END;{ZeigZeile}

BEGIN {BitMap}
  xoff:=xoff1;
  yoff:=yoff1;
  BlockRead(WPG,bmbreite,2);
  BlockRead(WPG,bmhoehe,2);
  BlockRead(WPG,cbpp,2);
  BlockRead(WPG,bmxppz,2);
  BlockRead(WPG,bmyppz,2);
  If Ioresult<>0 then
  begin
    ende:=true;
    exit;
  end;
  dec(BytesPacked,10);	        {... um die 10 eben gelesenen Bytes}
  {Manchmal braucht man fr's letzte Bit halt ein ganzes Byte:}
  Laenge:=(bmbreite*cbpp+7)div 8;

  Zeile:=NIL;
  Diesezeile:=NIL;
  Unterzeile:=NIL;
  Fehler1:=NIL;
  Fehler2:=NIL;
  Puffer:=NIL;
  ZeilenPufferLaenge:=Laenge+4;
  if maxavail<ZeilenPufferLaenge
  then ende:=true
  else getmem(Zeile,ZeilenPufferLaenge);

  If EinsZuEins THEN
  BEGIN
    bmxvaria:=Eins; {Eins ist $10000, fr meine LongInt-Rundungen}
    bmyvaria:=Eins;
  END ELSE
  BEGIN
    bmxvaria:=round(1.0*xvaria*(x2-x1+1)/bmbreite);
    bmyvaria:=round(1.0*yvaria*(y2-y1+1)/bmhoehe);
  END;
  ZoomDiesBitMap:=(ZoomBitMap or bitmap2) and ((BMXVaria>Eins) or (BMYVaria>Eins));
  If Not ZoomDiesBitmap Then
  BEGIN
    if bmxvaria>Eins then
     begin
       bmyvaria:=round(1.0*bmyvaria/bmxvaria*Eins);
       bmxvaria:=Eins;
     end;
    if bmyvaria>Eins then
     begin
       bmxvaria:=round(1.0*bmxvaria/bmyvaria*Eins);
       bmyvaria:=Eins;
     end;
  END;

  bmxoff:=xoff+longint(hiword(xvaria*x1));

  iF ZOOMBITMAP or bitmap2 THEN
  y_alt:=yoff-hiword(yvaria*y2)-1
  ELSE
  y_alt:=-1; {Damit die erste Zeile gezeichnet wird. Wenn nicht
	   gezoomt wird, soll jede Bildschirmzeile (auer bei
	   MonochromBitmaps) nur einmal gemalt werden.}

  {Welches Schweinderl htten's denn gern?}
  If ZoomDiesBitmap
  Then
    If Monochrom Then
      @PutPixel:=@MonoZoomFarbe
    ELSE
    if (getmaxcolor=15) and (cbpp=8) {Zuviele Farben fr Bildschirm}
      then
      if Graustufen
      THEN
	begin
	  initgrau16;
	  @putpixel:=@zoomputpixel256auf16;
	end
      ELSE
	begin
	  @putpixel:=@egazoom256;
	end
      else
	@PutPixel:=@ZoomPutPixel
  ELSE {Nicht gezoomt:}
    if Monochrom
    then
      if cbpp=1 {Monochromes Bitmap}
      then
	if Hercules and not bitmap2
	Then @putpixel:=@HercPutMono
	else @putpixel:=@graph.putpixel
      else      {Farbiges Bitmap}
      if not NimmFloyd
	 then @putpixel:=@MonoPutFarbe_OD
	 else
	   if Hercules and not bitmap2
	   THEN @putpixel:=@HercPutFarbe
	   ELSE @putpixel:=@MonoPutFarbe
    else {Farbige Darstellung}
      if (getmaxcolor=15) and (cbpp=8) {Zuviele Farben fr Bildschirm}
      then
      if Graustufen
      THEN
	begin
	  initgrau16;
	  @putpixel:=@putpixel256auf16;
	end
      ELSE
	begin
	  if NOT NimmFloyd then
	  @putpixel:=@egaput256_od
	  else
	  @putpixel:=@egaput256;
	end
      else @putpixel:=@graph.putpixel; {Standardfarbdarstellung}

  if @PutPixel=@egaput256 then
	 begin
	   if maxavail<2*sizeof(Tripelzeilentyp)
	   then ende:=true
	   else
	   begin
	     new(diesezeile);
	     new(unterzeile);
	     fillchar(diesezeile^,sizeof(diesezeile^),#0);
	     fillchar(unterzeile^,sizeof(unterzeile^),#0);
	   end;
	 end
  else
  if (@PutPixel=@monoputfarbe) or
     (@PutPixel=@hercputfarbe) then
	 if maxavail<2*sizeof(monodithlinetyp)
	 then ende:=true
	 else
	 begin
	   new(fehler1);
	   new(fehler2);
	   fillchar(fehler1^,sizeof(fehler1^),#0);
	   fillchar(fehler2^,sizeof(fehler2^),#0);
	 end;
  if (@PutPixel=@EgaPut256)
  or (@PutPixel=@EgaPut256_OD)
  or (@PutPixel=@EgaZoom256)
  THEN InitEGA256;

  if not ende then
  begin
  MaxPuffer:=lmin(maxavail,sizeof(puffertyp));
  getmem(puffer,maxpuffer);
  WPGPos:=MaxPuffer+1;    {Damit ReadWPGByte berhaupt aus der Datei liest}
  MaxWPGPosErwartet:=MaxPuffer; {ColoRix schafft es, obwohl es nicht einmal
				 komprimiert, die falsche Lnge in die WPG-
				 Datei einzutragen. ZEIGWPG liest dann ein-
				 fach weiter, wenn das Bild noch nicht fertig
				 aufgebaut ist...}
  if not infogefunden and not bitmap2 then
  WRITESL(' Bitmap '+ls(bmbreite)+' x '+ls(bmhoehe)+
	  ' x '+ls(1 shl cbpp)+'.',FALSE);

  {Abschneiden des Mlls im letzten Byte:}
  Case cbpp of
  1: BEGIN
     case bmbreite mod 8 of
     0:EndFuell:=0;
     1:EndFuell:=127;
     2:EndFuell:=63;
     3:EndFuell:=31;
     4:EndFuell:=15;
     5:EndFuell:=7;
     6:EndFuell:=3;
     7:EndFuell:=1;
     end;
     {Monochrom heit schwarz auf wei, GRAB hat bestimmt wieder
      Mll in der Palette}
     if not bitmap2 then
     begin
       SetRGBPalette(0,0,0,0);
       SetRGBPalette(GetmaxColor,255,255,255);
     end;
     end;
  4: BEGIN
     case bmbreite mod 2 of
     0:EndFuell:=0;
     1:EndFuell:=15;
     end;
     If Graustufen Then {256er Graupalette falsch}
	for n:=0 to 15 do SetRGBPalette(n,n*17,n*17,n*17);
     If GetMaxColor=255 then {ist 255 bestimmt wieder schwarz!}
	SetRGBPalette(255,255,255,255);
     END;
  else endfuell:=0;
  end {case cbpp};

  n:=1 shl(CBpP)-1;
  If Not (PalGesetzt or palignore or BitMap2) Then
    For i:=0 to n do SetRGBPalette(i,255*i div n,255*i div n,255*i div n);

  if ausblenden then fade_in(RGBPalette,0,n);

  PalGesetzt:=TRUE;

  if (monochrom or (cbpp=1))
      and
     (hgreduziert and not ineinanderzeichnen or bitmap2)
      then
  {damit nur schwarze Pixel gesetzt werden mssen}
    begin
      setfillstyle(solidfill,getmaxcolor);
      IF  (BMXVaria<Eins+200)
      THEN
      If BitMap2 or zoombitmap
      Then
      BAR(xoff+hiword(xvaria*(x1)),
	  yoff-hiword(yvaria*(y1)),
	  xoff+hiword(xvaria*(x2)),
	  yoff-hiword(yvaria*(y2)))
      ELSE
      BAR(xoff+hiword(xvaria*(x1)),
	  hiword(yvaria*(y1)),
	  xoff+hiword(xvaria*(x2)),
	  hiword(yvaria*(y2)));
    end;

  YLauf:=1;
  BytesZuviel:=0;
  Repeat {Lese alle Zeilen:}
    xLauf:=1;
    ZeileWiederholt:=FALSE;
    REPEAT {Lese eine Zeile:}
      b1:=ReadWPGByte;
      If (b1 and 128)=0 {Keine Wiederholung}
      THEN
      BEGIN
       IF B1=0 THEN {Letzte Zeile b2-mal wiederholen}
       BEGIN
	 If Zoomdiesbitmap then inc(ylauf,readwpgbyte-1)
	 else
	 For Lauf:=2 to ReadWPGByte do ZeigZeile(Zeile,Laenge,TRUE);
	     {einmal wird sie unten noch gezeigt}
         Zeilewiederholt:=TRUE;
       END
     ELSE {b1 unterschiedliche Bytes (1..127) folgen}
     BEGIN
       IF WPGPos+b1>MaxPuffer {ist noch nicht alles im Puffer}
       THEN {mu zwischendurch von Disk gelesen werden}
	 For Lauf:=1 to b1 do
	 BEGIN
	   Zeile^[XLauf]:=ReadWPGByte; {ganz schn langsam}
	   INC(XLauf);
	 END
       ELSE {holen wir's gleich aus dem Puffer}
	 BEGIN
	   Move(Puffer^[WPGPos],Zeile^[XLauf],b1);
	   inc(wpgpos,b1);
	   inc(XLauf,b1);
	 END
     END
      END
      ELSE {Bit 7 von b1 gesetzt: Wiederholung}
      BEGIN
       IF B1=128 THEN {Wiederhole $FF b2-mal}
       BEGIN
         b2:=ReadWPGByte;
	 FillChar(Zeile^[XLauf],b2,#255);
	 inc(XLauf,b2);
       END
     ELSE {Bits 0-6 von b1 gesetzt: Zhler Byte wiederholen}
       BEGIN
	 b1:=b1 and 127;
	 FillChar(Zeile^[XLauf],b1,char(ReadWPGByte));
	 inc(XLauf,b1);
       END;
      END;
    Until (XLauf > Laenge) or ZeileWiederholt or ende;
    if not zeilewiederholt then
      Zeile^[Laenge]:=Zeile^[Laenge] or EndFuell;
    ZeigZeile(Zeile,Laenge,FALSE);
    ende:=ende or keypressed;
  Until (yLauf>bmhoehe) or ende;
  FREEMEM(puffer,MAXPUFFER);

  if not infogefunden then
  If BytesZuviel>0
    then WriteSL(' '+ls(Byteszuviel)+' Fehlbyte!',false);
  end; {Kein Fehler bei der Speicherzuweisung}

  if zeile<>nil then FREEMEM(ZEILE,ZeilenPufferlaenge);
  if Diesezeile<>nil then Dispose(diesezeile);
  if Unterzeile<>nil then Dispose(unterzeile);
  if Fehler1<>nil then Dispose(fehler1);
  if Fehler2<>nil then Dispose(fehler2);

END;{BITMAP}

(*---------------------------------------------------------------------
	   BEHANDLUNG EINES UNBEKANNTEN DATENSATZTYPS
---------------------------------------------------------------------*)

Procedure LiesDummy(l:longint);
{Nicht auszuwertenden Datensatz berspringen}
BEGIN
  seek(wpg,filepos(wpg)+l);
END;

(*---------------------------------------------------------------------
		  DICKE ZU ZEICHNENDER LINIEN
---------------------------------------------------------------------*)

Function BGILinienBreite(breite:Word):word;
{  Das BGI untersttzt nur Linien der Breite 1 und 3 Pixel.
 Linien, die auf dem Bildschirm bis 2 Pixel breit wren, werden
 durch einfach dicke Linien dargestellt, Linien mit 3 oder 4
 Pixel Sollbreite werden durch 3 Pixel breite Linien dargestellt.
 Breitere Linien werden als ausgeflltes Rechteck mit abgerundeten
 Enden gemalt. Die Kennung dafr ist 2.
   Diese Merkwrdigkeit entstand daraus, da die ganz dicken Linien
 erst ziemlich spt ins Programm eingebaut wurden.}
BEGIN
       IF nullbreite THEN Breite:=1
  else Breite:=hiword(Breite*xvaria);

       IF Breite<3 THEN BGILINIENBREITE:=1
  else IF Breite<5 THEN BGILINIENBREITE:=3
  Else BGILINIENBREITE:=2;
END;

(*---------------------------------------------------------------------
		       LINIE mit STRICHSTRKE
---------------------------------------------------------------------*)

Procedure Dickelinie(x1,y1,x2,y2,breite:integer);
VAR i,dx,dy:integer;
    hyp:longint;
    p:Array[1..5] of Pointtype; {Eckpunkte des Rechtecks}
CONST x_alt:integer=0; {Koordinaten abgerundeter Enden}
      y_alt:integer=0;
BEGIN
  If (LineAtt.Style=0)
  or ((x1<0) and (x2<0))
  or ((y1<0) and (y2<0))
  or ((x1>maxx) and (x2>maxx))
  or ((y1>maxy) and (y2>maxy))
  then Exit;

  hyp:=round(sqrt(sqr(1.0*y2-y1)+sqr(1.0*x2-x1))*2);
       {Hypotenuse fr Winkelberechnungen statt sin/cos/atn}
       {*2 weil unten nur die halbe Breite gebraucht wird}

  if hyp=0 {Sollte nie vorkommen, aber Nulldivision
	    ist tckisch...}
  then
  begin
    dx:=0;
    dy:=0;
  end
  else
  begin
    dx:=hiword(Breite*(longint(y2)-y1)*xvaria div hyp);
    dy:=hiword(Breite*(longint(x1)-x2)*yvaria div hyp);
  end;


  p[1].x:=x1-dx;
  p[2].x:=x2-dx;
  p[3].x:=x2+dx;
  p[4].x:=x1+dx;
  p[1].y:=y1-dy;
  p[2].y:=y2-dy;
  p[3].y:=y2+dy;
  p[4].y:=y1+dy;
  p[5]:=p[1];

  setcolor(lineatt.color);
  setlinestyle(solidln,0,NormWidth);
  setfillstyle(solidfill,lineatt.color);
  Fillpoly(4,P);

  {Die Enden werden abgerundet, wenn sie nicht
  zu einem Polygonzug gehren}
  IF (x1<>x_alt) or (y1<>y_alt) THEN
    Fillellipse(x1,y1,hiword(breite*xvaria div 2),hiword(breite*yvaria div 2));

  Fillellipse(x2,y2,hiword(breite*xvaria div 2),hiword(breite*yvaria div 2));

  x_alt:=x2;
  y_alt:=y2;

  IF lineatt.color=0 THEN DrawPoly(5,p);
    {Weil TP Bei FillPoly keine schwarzen Randlinien kann!}

  With Fillatt do BEGIN
  IF Pattern=255 THEN SetFillPattern(HGMuster,HGFarbe)
  ELSE
  IF Monochrom
  THEN
  BEGIN
    SetFillPattern(MonoPattern[GrauPalette[color]div 4],GetMaxColor);
  END
  ELSE
  BEGIN
    SetFillStyleNoBlack(Pattern,Color);
  END;
  END;
END;


(*---------------------------------------------------------------------
			       POLYLINIE
---------------------------------------------------------------------*)
CONST MaxPoints=16383; {Mehr pat nicht in 64K}

procedure POLYLINIE;
TYPE feldtyp=array[1..MaxPoints]of PointType;
VAR i,n	:word;
    xy	:^feldtyp;
BEGIN
  BlockRead(WPG,n,2);
  IF (n>MaxPoints)
  OR (maxavail<4*n)
  OR (Lineatt.Style=0)
  THEN
  BEGIN
    LiesDummy(4*n);
    UnBekanntes:=TRUE;
    EXIT;
  END;

  getmem(xy,4*n);
  BlockRead(WPG,xy^,4*n);

 IF bgilinienbreite(lineatt.width)<>2 THEN
  BEGIN
    moveto(xoff+hiword(xvaria*xy^[1].x),yoff-hiword(yvaria*xy^[1].y));
    for i:=2 to n do
      lineto(xoff+hiword(xvaria*xy^[i].x),yoff-hiword(yvaria*xy^[i].y));
  END
  else
  BEGIN
    for i:=2 to n do
      Dickelinie(xoff+hiword(xvaria*xy^[i-1].x),yoff-hiword(yvaria*xy^[i-1].y),
		 xoff+hiword(xvaria*xy^[i].x),yoff-hiword(yvaria*xy^[i].y),
		 lineatt.width);
  END;

  FREEMEM(xy,4*n);
END; {PolyLinie}


(*---------------------------------------------------------------------
			   BEZIER-KURVE
			 Die Spline-Curve
		     zuerst mal nur als Polylinie
---------------------------------------------------------------------*)
Procedure BEZIER(reclen:longint);
TYPE feldtyp=array[1..MaxPoints]of PointType;
VAR i,n	:word;
    wp5size:Longint;
    xy	:^feldtyp;
BEGIN
  BlockRead(WPG,wp5size,4); {Wenn hier ein Wert steht, so ist die
			     Bildinformation doppelt. Anstelle von
			     Bzier-Kurven werden Polylinien
			     eingesetzt}
  If WP5Size<>0 then
  begin
    Liesdummy(reclen-4);
    exit;
  end;

  BlockRead(WPG,n,2);
  IF (n>MaxPoints)
  OR (maxavail<4*n)
  THEN
  BEGIN
    LiesDummy(4*n);
    UnBekanntes:=TRUE;
    EXIT;
  END;

  getmem(xy,4*n);
  BlockRead(WPG,xy^,4*n);

  IF bgilinienbreite(lineatt.width)<>2 THEN
   BEGIN
     moveto(xoff+hiword(xvaria*xy^[1].x),yoff-hiword(yvaria*xy^[1].y));
     for i:=2 to n do
       lineto(xoff+hiword(xvaria*xy^[i].x),yoff-hiword(yvaria*xy^[i].y));
   END
   else
   BEGIN
     for i:=2 to n do
       Dickelinie(xoff+hiword(xvaria*xy^[i-1].x),yoff-hiword(yvaria*xy^[i-1].y),
		  xoff+hiword(xvaria*xy^[i].x),yoff-hiword(yvaria*xy^[i].y),
		  lineatt.width);
   END;
  FREEMEM(xy,4*n);
END; {BEZIER}

(*---------------------------------------------------------------------
		      AUSGEFLLTES POLYGON
---------------------------------------------------------------------*)

Procedure Polygon;
TYPE feldtyp=array[1..MaxPoints]of PointType;
VAR i,vertices,x,y:word;
    xy		:^feldtyp;
BEGIN
  BlockRead(WPG,Vertices,2);
  IF (Vertices>=MaxPoints)
  OR (maxavail<4*succ(Vertices))
  THEN
  BEGIN
    LiesDummy(4*Vertices);
    UnBekanntes:=TRUE;
    EXIT;
  END;
  getmem(xy,4*succ(Vertices));
  BlockRead(WPG,xy^,4*Vertices);
  For i:=1 to Vertices do with xy^[i] do
    {Umrechnen auf Bildschirmkoordinaten}
    BEGIN
      x:=xoff+hiword(word(x)*xvaria);
      y:=yoff-hiword(word(y)*yvaria);
    END;

  xy^[Vertices+1]:=xy^[1];

  IF fillatt.pattern>0 THEN
  BEGIN
    IF lineatt.style=0 THEN
    begin
       setlinestyle(userbitln,0,1);
       setcolor(0);
       {TP 5.5 malt dann nicht schwarze, sondern GAR KEINE Linien}
    end
    else
     IF fillatt.pattern=255 THEN {Hintergrundmuster}
       setzfarbe(fillatt.color)
     ELSE
       setzfarbe(lineatt.color);

    IF Monochrom
    THEN
    BEGIN
      IF Fillatt.Pattern=255
      THEN SetFillPattern(HGMuster,HGFarbe)
      ELSE SetFillPattern(MonoPattern[GrauPalette[fillatt.color]div 4],
			  GetMaxColor);
      SetFillStyle(UserFill,0);
    END
    ELSE SetFillStyleNoBlack(fillatt.Pattern,fillatt.color);
    fillpoly(Vertices,xy^);

    setlinestyle(SolidLn,0,bgilinienbreite(lineatt.width));
  END;

  setzfarbe(lineatt.color);
  IF (lineatt.style>0) THEN
  BEGIN
    IF bgilinienbreite(lineatt.width)<>2 THEN
    BEGIN
      moveto(xy^[1].x,xy^[1].y);
      for i:=2 to Vertices+1 do
	lineto(xy^[i].x,xy^[i].y);
    END
    else
    BEGIN
      for i:=2 to Vertices+1 do
	Dickelinie(xy^[i-1].x,xy^[i-1].y,
		   xy^[i].x,xy^[i].y,lineatt.width);
    END;
  END;
  FREEMEM(xy,4*succ(Vertices));
END; {Polygon}


(*---------------------------------------------------------------------
			       ELLIPSE
---------------------------------------------------------------------*)

Procedure ELLIPSE; {Ist ein Provisorium, das lange nicht alles macht...}
VAR x0,y0,rx,ry,rowi,stawi,endwi,hilf,flag,anz:integer;
    x,y,cr,sr,wi:real;
    p:array[0..42] of PointType;
    n:word;

const pi180=pi/180;

BEGIN
  BlockRead(WPG,x0,2);
  BlockRead(WPG,Y0,2);
  BlockRead(WPG,rx,2);
  BlockRead(WPG,ry,2);
  BlockRead(WPG,rowi,2);
  BlockRead(WPG,stawi,2);
  BlockRead(WPG,endwi,2);
  BlockRead(WPG,flag,2);

  if rx=ry then
  begin
    inc(stawi,rowi);
    inc(endwi,rowi);
    rowi:=0;
  end;

  if rowi<>0 then
  case rowi of
  90:begin
       rowi:=0;
       Hilf:=rx; rx:=ry; rx:=hilf;
       inc(stawi,90);
       inc(endwi,90);
     end;
  270:begin
       rowi:=0;
       Hilf:=rx; rx:=ry; rx:=hilf;
       inc(stawi,270);
       inc(endwi,270);
     end;
  180:begin
       rowi:=0;
       inc(stawi,180);
       inc(endwi,180);
     end;
  end; {case}

  rowi:=rowi mod 360;
  IF endwi<=stawi THEN inc(endwi,360);

  If                               {Ellipse mit Unit Graph zeichenbar}
       (Flag<>0)          {Abschnitt oder Sektor (nicht ganz richtig)}
    or (    (RoWi=0)                       {Hauptachsen nicht gedreht}
	and (bgilinienbreite(lineatt.width)<>2)) {keine dicken Linien}
    and (Lineatt.Style>0)           {Wieso malt die immer Randlinien?}
  THEN
  BEGIN
    x0:=xoff+hiword(x0*xvaria);
    y0:=yoff-hiword(y0*yvaria);
    rx:=hiword(rx*xvaria);
    ry:=hiword(ry*yvaria);
  END;

  IF (RoWi>0) and (rx<>ry) and (flag<>0)
  THEN Unbekanntes:=TRUE;
  {Unbekannt sind also gedrehte Ellipsensektoren und
   gedrehte Ellipsenabschnitte.
   Mit DrawPerfect 1.1 kann man aber weder Ellipsensektoren
   noch Ellipsenabschnitte zeichnen, daher wird dieses Manko
   wohl kaum so schnell in einer Zeichnung auftauchen...}

  If lineatt.style=0 then
  begin
    setlinestyle(userbitln,0,1);

    setcolor(fillatt.color);
  end;

  Case Flag of
   0: If (rowi=0) and (bgilinienbreite(lineatt.width)<>2) and (lineatt.style>0) Then
	IF (fillatt.pattern=0) or (endwi-stawi<360)
	THEN GRAPH.ELLIPSE(x0,y0,stawi,endwi,rx,ry)
	else GRAPH.FILLELLIPSE(x0,y0,rx,ry)
      ELSE
	BEGIN
	  cr:=cos(rowi*pi180);
	  sr:=sin(rowi*pi180);
	  anz:=42*abs(endwi-stawi) div 360;
	  if anz<2 then anz:=2 else if anz>42 then anz:=42;
	  for n:=0 to anz do
	  begin
	   wi:=pi180*(stawi+n/anz*(endwi-stawi));
	   x:=cos(wi)*rx;
	   y:=sin(wi)*ry;
	   p[n].x:=xoff+hiword(xvaria*(x0+round(x*cr-y*sr)));
	   p[n].y:=yoff-hiword(yvaria*(y0+round(x*sr+y*cr)));
	  end;
	  if fillatt.pattern>0 then fillpoly(anz+1,p);
	  setzfarbe(lineatt.color);
	  IF (lineatt.style>0) THEN
	  BEGIN
	    IF bgilinienbreite(lineatt.width)<>2 THEN
	    BEGIN
	      moveto(p[0].x,p[0].y);
	      for n:=1 to anz do
		lineto(p[n].x,p[n].y);
	      lineto(p[0].x,p[0].y);
	    END
	    else
	    BEGIN
	      for n:=1 to anz do
		Dickelinie(p[n-1].x,p[n-1].y,
			   p[n].x,p[n].y,lineatt.width);
	    END;
	  END;
	END;
   1: Sector(x0,y0,stawi,endwi,rx,ry);
   2: BEGIN
	Sector(x0,y0,stawi,endwi,rx,ry);
	{Stimmt nicht ganz, ist eigentlich ein gefllter Ellipsenabschnitt!}
	Unbekanntes:=TRUE;
	{Ist aber nicht schlimm, die kommen sowieso nie vor, jedenfalls
	 kenne ich (Okt.91) kein Programm, mit dem man die Dinger
	 zeichnen knnte}
      END;
  END;
END; {ELLIPSE}

(*---------------------------------------------------------------------
			       RECHTECK
---------------------------------------------------------------------*)

Procedure Rechteck;
VAR x0,y0,lx,ly	:word;
BEGIN
  BlockRead(WPG,x0,2); x0:=xoff+hiword(x0*xvaria);
  BlockRead(WPG,Y0,2); y0:=yoff-hiword(y0*yvaria);
  BlockRead(WPG,lx,2); lx:=hiword(lx*xvaria);
  BlockRead(WPG,ly,2); ly:=hiword(ly*yvaria);
  IF fillatt.pattern=0 THEN
    rectangle(x0,y0,x0+lx,y0-ly)
  ELSE
    BAR(x0,y0,x0+lx,y0-ly);
END;

(*---------------------------------------------------------------------
			       LINIE
---------------------------------------------------------------------*)

Procedure Linie;
VAR x1,y1,x2,y2:word;

BEGIN
  BlockRead(WPG,x1,2);
  BlockRead(WPG,y1,2);
  BlockRead(WPG,x2,2);
  BlockRead(WPG,y2,2);

  IF bgilinienbreite(lineatt.width)<>2 THEN
    LINE(xoff+hiword(x1*xvaria),yoff-hiword(y1*yvaria),
	 xoff+hiword(x2*xvaria),yoff-hiword(y2*yvaria))
  ELSE
    DickeLinie(xoff+hiword(x1*xvaria),yoff-hiword(y1*yvaria),
	       xoff+hiword(x2*xvaria),yoff-hiword(y2*yvaria),
	       lineatt.width);
END;

(*---------------------------------------------------------------------
			     LINIENATTRIBUTE
---------------------------------------------------------------------*)

Procedure Linienattribute;
VAR tpStyle:Byte;
BEGIN with lineatt do BEGIN
  BlockRead(WPG,style,1);
  case style of
     2,5,7,12:     tpStyle:=3; {Gestrichelt}
     3,10,11:      tpStyle:=1; {Gepunktet}
     4,6,8,13..15: tpStyle:=2; {Strichpunktiert}
     else          tpStyle:=0; {Solid}
  END; {case}
  BlockRead(WPG,color,1);
  BlockRead(WPG,width,2);
  if linienbreite<>0 then width:=linienbreite;
  setwritemode(copyput);
  setlinestyle(tpstyle,0,bgilinienbreite(width));
  setzfarbe(color);
END;END; {Linienattribute}

(*---------------------------------------------------------------------
		   ERSTER RECORD IN EINER WPG-DATEI
---------------------------------------------------------------------*)

Procedure StartWPGdata(var virt_x1,virt_y1,virt_x2,virt_y2:longint);
VAR v1,v2	:real;
VAR xas,yas     :Word;
BEGIN
  BlockRead(WPG,wpgversion,1);
  BlockRead(WPG,postscript,1);
  BlockRead(WPG,wpgbreite,2);
  BlockRead(WPG,wpghoehe,2);
  If wpgbreite = 0 then wpgbreite:=1; {Corel Draw schreibt solchen Mist,}
  If wpghoehe = 0 then wpghoehe:=1;   {wenn keine Objekte exportiert wurden.}


  IF EinsZuEins
    THEN BEGIN Xas:=1; Yas:=1 END
  ELSE
    BEGIN
      GetAspectRatio(Xas,Yas);
      Xas:=round(Xas*10000.0/Breitenfaktor);
    END;

  v1:=1.0*(virt_x2-virt_x1+1)/wpgbreite;
  v2:=1.0*(virt_y2-virt_y1+1)/wpghoehe*Yas/Xas;
  nosound;
  {Je nachdem, ob das Bild zu hoch oder zu breit ist, wird
   v1 oder v2 genommen:}
  IF v1>v2 THEN
  BEGIN
    xvaria:=round(v2*Eins);
    yvaria:=round(v2*Xas/Yas*Eins);
  END
  ELSE
  BEGIN
    xvaria:=round(v1*Eins);
    yvaria:=round(v1*Xas/Yas*Eins);
  END;
  xoff:=virt_x1+((virt_x2-virt_x1)-hiword(xvaria*wpgbreite)) div 2; {links}
  yoff:=virt_y2-((virt_y2-virt_y1)-hiword(yvaria*wpghoehe))div 2; {unten}
END; {StartWPGdata}


(*---------------------------------------------------------------------
		     GRAFIKTEXT VARIANTE 1
---------------------------------------------------------------------*)

Procedure Gtext1;
VAR textlen,
    test_a,test_b,
    test_c,test_d:word;
    i,x,y,cs,cw,ccw,fontnr:word;
    s:string;
    textinfo:textsettingstype;
    horzvert:Byte;
BEGIN
  gettextsettings(textinfo);
  BlockRead(WPG,textlen,2);
  BlockRead(WPG,x,2);
  BlockRead(WPG,y,2);
  BlockRead(WPG,s[1],textlen);
  s[0]:=char(textlen);
  SetzFarbe(GTA.tc);

  {Leider sind nicht alle Winkel mglich, statt 0-360 leider
   nur 0 oder 90}
  IF ((GTA.rw>45) and (GTA.rw<=135))
  or ((GTA.rw>225) and (GTA.rw<=315))
  THEN
  begin
    horzvert:=vertdir;
    cs:=HiWord(xvaria*gta.cch);
    cw:=hiword(yvaria*gta.nccw);
  end
  else
  begin
    horzvert:=horizdir;
    cs:=HiWord(yvaria*gta.cch);
    cw:=hiword(xvaria*gta.nccw);
  end;

  case gta.fdf of
    $0d50: fontnr:=2; {3408: Small statt Courier}
    $1150: fontnr:=6; {4432: Simplex statt Helvetica}
    $1950: fontnr:=1; {6480: Roman Triplex}
      else fontnr:=0; {Font 8x8 fr Unbekanntes}
  END;


  IF FontNr=DefaultFont {ROM}
  THEN SetTextStyle(0,HorzVert,CS DIV 8)
  else
    BEGIN
      SetTextStyle(Fontnr,gta.rw,4);
      IF graphresult<>0 {Font nicht gefunden oder kein Speicher}
      THEN
	BEGIN
	  fontnr:=0;
	  SetTextStyle(0,HorzVert,cs div 8)
	END
      else
      begin
	{Jetzt folgt eine programmiertechnische Kapriole:
	 Die iterative Textgrenermittlung, weil die Skalierung
	 bei Turbo Pascal manchmal derben Mist produziert.}
	test_a:=1;
	test_b:=1;
	test_c:=1;
	test_d:=1;
	repeat
	  setusercharsize(test_a,test_b,test_c,test_d);
	  if textheight('A')<CS then inc(test_c) else inc(test_d);
	  if cw*length(s)>textwidth(s) then inc(test_a) else inc(test_b);
	until (cw*length(s)=textwidth(s))
	  and (textheight('A')=CS)
	  or (test_a=255)
	  or (test_b=255)
	  or (test_c=255)
	  or (test_d=255);
      end;
    END;

      IF FontNr=0
      THEN
	case gta.rw of
	  45..135: SetTextJustify(Righttext,Bottomtext);
	 135..225: SetTextJustify(Righttext,Toptext);
	 225..315: SetTextJustify(Lefttext,Toptext);
	      else SetTextJustify(Lefttext,Bottomtext);
	END {Case}
      ELSE
	SetTextJustify(GTA.ha,GTA.va);
      test_a:=graphresult;
      outtextxy(xoff+hiword(x*xvaria),yoff-hiword(y*yvaria),s);

  with textinfo do
  BEGIN
    SetTextJustify(horiz,vert);
  END;

  {Der Originalfont wird erst am Ende der Grafik
   wiederhergestellt, damit nicht dauernd die
   CHR-Dateien gewechselt werden, was langsam und
   laut ist}

END; {Gtext1}

(*---------------------------------------------------------------------
			   GRAFIKTEXT-ATTRIBUTE
---------------------------------------------------------------------*)

Procedure GtextAttr;
{Die Elemente des GTA-Headers sind in der TYPE-Deklaration beschrieben}
BEGIN With GTA do BEGIN
  BlockRead(WPG,nccw,2);
  BlockRead(WPG,cch,2);
  BlockRead(WPG,r5w,10);
  BlockRead(WPG,fdf,2);
  BlockRead(WPG,r1b,1);
  BlockRead(WPG,ha,1);
  BlockRead(WPG,va,1);
  BlockRead(WPG,tc,1);
  BlockRead(WPG,rw,2);
END END; {GtextAttr}


(*---------------------------------------------------------------------
			   FLLATTRIBUTE
---------------------------------------------------------------------*)


Procedure Fuellattribute;
{Flchenfllungen machen mit TP keinen Spa, weil der Hintergrund
 immer auf 0 gesetzt wird}
BEGIN With Fillatt do BEGIN
  BlockRead(WPG,pattern,1);
  BlockRead(WPG,color,1);
  IF Pattern=255 THEN SetFillPattern(HGMuster,HGFarbe)
  ELSE
  IF Monochrom
  THEN
  BEGIN
    SetFillPattern(MonoPattern[GrauPalette[color]div 4],GetMaxColor);
  END
  ELSE
  BEGIN
    SetFillStyleNoBlack(Pattern,Color);
  END;
END;END; {Fuellattribute}

(*---------------------------------------------------------------------
		   PALETTE DER WP-GRAFIK LESEN
---------------------------------------------------------------------*)

Procedure Palette;
VAR i	:word;
    gr	:Byte;
    rgb :record r,g,b:byte END;
BEGIN
  ZuVieleFarben:=FALSE;
  BlockRead(WPG,PalFirst,2);
  BlockRead(WPG,PalFarben,2);
  IF PalFarben>256 THEN PalFarben:=PalFarben div 3;
    {Weil Graphics Workshop hier 'ne Macke hat...}
  PalPos:=FilePos(WPG);
    {Damit die Palette auch zurckgeschrieben werden kann}
  For i:=PalFirst to PalFirst+PalFarben-1 do
  BEGIN
    If (i>GetMaxColor) and not monochrom Then Zuvielefarben:=TRUE;
      {Die Farben werden dann von SetRGBPalette nur gespeichert}
    BlockRead(WPG,rgb,3);
    IF Graustufen
    THEN
      BEGIN
	{WP-Palette}
	Gr:=hiword(eins*255*i div (PalFarben-1));
	SetRGBPalette(i,gr,gr,gr);
	IF Monochrom THEN GrauPalette[i]:=gr;
      END
    ELSE with rgb do
      BEGIN
	If Not Palignore then SETRGBPalette(i,r,g,b);
	IF Monochrom THEN GrauPalette[i]:=GrauWert(i);
      END;
  END;

  PalGesetzt:=TRUE;
  PalIgnore:=FALSE;
  IF ausblenden THEN Fade_in(RGBPalette,PalFirst,PalFirst+PalFarben-1);
END;


(*---------------------------------------------------------------------
		HEADER FR JEDEN RECORD LESEN
---------------------------------------------------------------------*)

Procedure HoleRecordHeader(VAR recnr:Byte; VAR reclen:Longint);
VAR b	:Byte;
    w	:Word;
BEGIN
    {Record-Typ:}
    BlockRead(WPG,recnr,1); if ioresult<>0 then ende:=true;
    {Record-Lnge:}
    BlockRead(WPG,b,1); if ioresult<>0 then ende:=true;
    IF b=255 THEN
    BEGIN
      BlockRead(WPG,w,2); if ioresult<>0 then ende:=true;
      IF (hi(w)and 128)=128
      THEN
      BEGIN
	reclen:=longint(w and $7FFF)*Eins;
	BlockRead(WPG,w,2); if ioresult<>0 then ende:=true;
	inc(reclen,w)
      END else reclen:=w;
    END else reclen:=b;
    if ende or (reclen+filepos(wpg)>filesize(wpg)) or (recnr=0)
    then
    begin
      {Font zurcksetzen.}
      IF fontnr=0 THEN
	SetTextstyle(0,0,Charsize div 8)
      ELSE
      BEGIN
	SetTextStyle(Fontnr,0,4);
	SetUserCharSize(Charsize,TextHeight('A'),Charsize,TextHeight('A'));
      END;
      if graphresult<>0 then;
      Settextjustify(Lefttext,TopText);
      writesl(' Datei beschdigt!',false);
      ende:=TRUE;
    end;
END;

(*---------------------------------------------------------------------
		 DARSTELLUNG EINES WPG-BITMAPS Typ 2
---------------------------------------------------------------------*)

PROCEDURE BITMAP2(Laenge:LongInt; VAR Unbekanntes:Boolean);
VAR RoWi,x1,y1,x2,y2:Integer;
BEGIN
  BlockRead(WPG,RoWi,2);
  BlockRead(WPG,x1,2);
  BlockRead(WPG,y1,2);
  BlockRead(WPG,x2,2);
  BlockRead(WPG,y2,2);
  Unbekanntes:=(RoWi mod 360)<>0;
  BITMAP(xoff,yoff,x1,y1,x2,y2,Laenge-10,TRUE);
END; {BITMAP2}



PROCEDURE ZEIGWPG(wpgname:pathstr;
		  var virt_x1,virt_y1,virt_x2,virt_y2:Longint;
		  var DarfZoomen:Boolean);
VAR Header:WPCHeaderTyp;
BEGIN
  assign(wpg,wpgname);
  reset(wpg,1);
  BlockRead(wpg,header,sizeof(header));
  {Start und sizeof(header) sollten gleich sein.
   Falls zwischen Header und Datenbereich tatschlich noch
   Krempel ist, wird dieser nun bersprungen.
   Diese Zeile macht ZEIGWPG WordPerfect-kompatibler als WordPerfect,
   das liest den Mll nmlich nicht weg und zeigt nichts mehr an.}
  seek(wpg,header.start);

  ende:=false;
  abgebrochen:=false;
  while NOT (abgebrochen or ende) do
  BEGIN
    HoleRecordHeader(RecNr,Reclen);
    If Not Ende Then
    {ENDE wird gesetzt, wenn RecLen zu lang ist, um in die Datei zu passen}
    BEGIN
    Case RecNr of
     1: Fuellattribute;
     2: Linienattribute;
     5: Linie;
     6: Polylinie;
     7: Rechteck;
     8: Polygon;
     9: Ellipse;
{$IFNDEF SEWVIEW}
    11: Begin
	  If einszueins or not ZoomBitMap then
	  begin
	  darfzoomen:=false;
	  if einszueins then xoff:=0;
	  BitMap(0,maxy, 0,0, wpgbreite,wpghoehe, RecLen,FALSE);
	  end
	  else
	  BitMap(xoff,yoff,0,0,wpgbreite,wpghoehe,RecLen,FALSE);
	End;
{$ENDIF}
    12: Gtext1;
    13: GtextAttr;
    14: Palette;
    15: StartWPGData(virt_x1,virt_y1,virt_x2,virt_y2);
    19: Bezier(RecLen);
{$IFNDEF SEWVIEW}
    20: BitMap2(RecLen,Unbekanntes);
{$ENDIF}
    31: Polygon; {Eigentlich Bezier-Flche}
    ELSE BEGIN
	   LiesDummy(RecLen);
	   {WPG_END, START_WPG_2, gepatcht oder wirklich unbekannt?}
	   IF NOT (RecNr in [
	     16, {WPG_END     (Gewolltes Dateiende)}
	     21, {START_FIG   (Blockmarkierung)}
	     22, {START_CHT   (Diagrammarkierung)}
	     25, {START_WPG_2 (Hintergrundfarbe, Vordergrundfarbe)}
	     255 {Gepatcht, um Bereiche auszuschlieen}
	     ]) THEN unbekanntes:=TRUE;
	 END;
    END; {CASE}
    IF (recnr in [5..9,11,12,19,20]) THEN zeichnungbegonnen:=true;
    ende:=ende or keypressed or (recnr=16) or eof(wpg);
    END; {Wenn der Record-Header ok war}
  END; {Solange nicht fertig}
  If PalPos=0 then SetEGARGB;
  LetzteWPGDatei:=wpgname;
  close(wpg); if ioresult<>0 then;
END; {Wenn WPG-Datei}


BEGIN END.
